clear;
clc;
addpath('Functions')
%NOTE: set ``step" smaller for finer grid. 
%Last code check; 3.9.2019, Nigel

tic 
%outside of loops
    S=2;
    p11=.95; p22=.95; 
    p12=1-p11; p21=1-p22;
    P=[p11 1-p11;1-p22 p22];
    rho=0; %set rho to zero for simple model with short-term debt
    beta=.99; 
    sig=1;
    kappa=.1;
    C1=zeros(4);
    R=zeros(4); 
    phi{1}=0;
    phi{2}=0;
    Z=[];
  
 
step=.00025; %make step smaller to make things more refined
for g1=.01:step:.08
for g2=-.08:step:.01
     
gamma{1}=g1;
gamma{2}=g2;
  
 
            for j=1:S, 
                B1{j,1}=[1 -kappa 0 0;...
                    sig*phi{j} 1 0 0;...
                    (1/beta) 0 1 1-rho+gamma{j}*beta*rho;...
                    phi{j} 0 0 1];
                 
                A1{j}=[beta 0 0 0;...
                         sig 1 0 0;...
                         0 0 0 0;...
                         0 0 0 beta*rho];
                B2{j}=[zeros(2,4);...
                      0 0 (1/beta)-gamma{j} 0;...
                      0 0 0 0];
                   
                   
                A{j,1}=B1{j}\A1{j}; 
                B{j,1}=B1{j}\B2{j}; 
                C{j,1}=B1{j}\C1;                       
            end
             
    [DET,FCC,OmegaK,GammaK,FK,OtherOutput,IRS]=fmmsre(P,A,B,C,R);
             
    Estab1_mat=[p11*kron(OmegaK{1,1}',FK{1,1}) p12*kron(OmegaK{1,1}',FK{1,1});...
                p21*kron(OmegaK{2,1}',FK{2,1}) p22*kron(OmegaK{2,1}',FK{2,1})];
    Estab2_mat=[p11*FK{1,1} p12*FK{1,1};...
                p21*FK{2,1} p22*FK{2,1}];
    Estab=max([max(abs(eig(Estab1_mat))),max(abs(eig(Estab2_mat)))]);
     
   if max(DET)<1 && Estab<1,
       k=1;
   elseif Estab<1,
       k=2;
   else k=3;
   end
         
 
   Z=[Z; gamma{1} gamma{2} max(DET) Estab k];
     
     
   end
end
 
 
ZZZ=[.01 .01];
zzz=[.01 .01];
 
for iii=2:size(Z,1)-1
    if Z(iii,5)==1 && Z(iii+1,5)==2 || Z(iii,5)==1 && Z(iii+1,5)==3
        ZZZ=[ZZZ;Z(iii,1:2)];
    end
        if Z(iii,5)==3 && Z(iii-1,5)==2 %|| Z(iii,5)==3 && Z(iii-1,5)==1
        zzz=[zzz;Z(iii,1:2)];
    end
end
  
 
%%
figure(6)
basevalue = -.1;
 
hold on
 
 
samplingRateIncrease = 1;
newXSamplePointsZZZ = linspace(ZZZ(1,1), ZZZ(size(ZZZ,1),1), size(ZZZ,1)*samplingRateIncrease);
smoothedZZZ = spline(ZZZ(:,1),ZZZ(:,2),newXSamplePointsZZZ);
 
 
newXSamplePointszzz = linspace(zzz(1,1), zzz(size(zzz,1),1), size(zzz,1)*samplingRateIncrease);
smoothedzzz = spline(zzz(:,1),zzz(:,2),newXSamplePointszzz);
 
 
h1=area(newXSamplePointszzz, smoothedzzz,basevalue,'LineStyle',':')
h1.FaceColor = [0.7 0.7 0.7];
hold on
h2=area(newXSamplePointsZZZ, smoothedZZZ,basevalue,'LineStyle',':')
h2.FaceColor = [0.2 0.2 0.2];
axis([.01 .08 -.08 .01])
 
 
 set(gca,...
    'XTickLabel',{'.01' '.02' '.03' '.04' '.05' '.06' '.07' '.08'},...
    'XTick',[.01 .02 .03 .04 .05 .06 .07 .08]);
 set(gca,...
    'YTickLabel',{'-.08' '-.07' '-.06' '-.05' '-.04' '-.03' '-.02' '-.01' '0' '.01'},...
    'YTick',[-.08 -.07 -.06 -.05 -.04 -.03 -.02 -.01 0 .01],'FontName', 'Times','FontSize',13);

xlabel('\gamma(M)','FontSize',22,'FontName', 'Times')
ylabel('\gamma(F)','FontSize',22,'FontName', 'Times')



plot(.049,-.05,'r*','MarkerSize',10,'LineWidth',1)
plot(.06,-.05,'bs','MarkerFaceColor','black','MarkerSize',7)
plot(.06,-.02,'bd','MarkerFaceColor','blue')
legend('Indeterminate and IE-stable','Determinate and IE-stable','A','B','C')
% legend('Indeterminate and IE-stable','Determinate and IE-stable','A','B','C','FontName', 'Times','FontSize',11)
% legend('boxoff')
%  

print('Name_of_file','-dpdf','-fillpage')
 
 
     toc