%Last code check: 3.9.2019, Nigel

clear;
clc;
addpath('Functions')
 
 
 
 
%% E-stab indet 
Tstar=49999;   %T*=period in which shock occurs (T^a=1). When plotted with T^a=0, the shock is T^*-1 periods in the future.
tstar=Tstar-1; %length of shock (one period)
n=4;           %# endo vars
S=2;           %# Markov states
ibar=-1/400;       %T* shock size
 
Omeg{1}=zeros(n,n,Tstar+1);  %b{1} matrix
Omeg{2}=zeros(n,n,Tstar+1);  %b{2} matrix
Ct{1}=zeros(n,1,Tstar+1);    %a{1} matrix
Ct{2}=zeros(n,1,Tstar+1);    %a{2} matrix
 
    S=2;
    p11=.95; p22=.95; 
    p12=1-p11; p21=1-p22;
    P=[p11 1-p11;1-p22 p22];
    rho=0;
    beta=.99; 
    sig=1;
    kappa=.1;
    C1=zeros(4);
    R=zeros(4); 
    gamma{1}=.05;
    gamma{2}=-.05;
    phi{1}=1.5;
    phi{2}=0;
     
     
    % RE Solutions (x=(pi y b P))
             
            for j=1:S, 
                B1{j,1}=[1 -kappa 0 0;...
                    sig*phi{j} 1 0 0;...
                    (1/beta) 0 1 1-rho+gamma{j}*beta*rho;...
                    phi{j} 0 0 1];
                 
                A1{j}=[beta 0 0 0;...
                         sig 1 0 0;...
                         0 0 0 0;...
                         0 0 0 beta*rho];
                B2{j}=[zeros(2,4);...
                      0 0 (1/beta)-gamma{j} 0;...
                      0 0 0 0];
                   
                   
                A{j,1}=B1{j}\A1{j}; 
                B{j,1}=B1{j}\B2{j}; 
                C{j,1}=B1{j}\C1;                   
            end
             
            [DET,FCC,OmegaK,GammaK,FK,OtherOutput,IRS]=fmmsre(P,A,B,C,R);
DET1=DET;
FCC1=FCC;
             
fp1=max([max(max(OmegaK{1,1}-(eye(n)-A{1,1}*(p11*OmegaK{1,1}+p12*OmegaK{2,1}))\B{1,1})),max(max(OmegaK{2,1}-(eye(n)-A{2,1}*(p21*OmegaK{1,1}+p22*OmegaK{2,1}))\B{2,1}))]);
 
 
Omeg{1}(:,:,Tstar+1)=OmegaK{1,1};
Ct{1}(:,:,Tstar+1)=zeros(4,1);
Omeg{2}(:,:,Tstar+1)=OmegaK{2,1};
Ct{2}(:,:,Tstar+1)=zeros(4,1);
 
% FG Horizon
 
            for j=1:S, 
                B1{j,1}=[1 -kappa 0 0;...
                    0 1 0 0;...
                    (1/beta) 0 1 1-rho+gamma{j}*beta*rho;...
                    0 0 0 1];
                 
                A1{j}=[beta 0 0 0;...
                         sig 1 0 0;...
                         0 0 0 0;...
                         0 0 0 beta*rho];
                B2{j}=[zeros(2,4);...
                      0 0 (1/beta)-gamma{j} 0;...
                      0 0 0 0];
                   
                   
                A{j,1}=B1{j}\A1{j}; 
                B{j,1}=B1{j}\B2{j}; 
                C{j,1}=B1{j}\C1;   
                gam1{j}=B1{j}\[0;-sig*ibar;0;-ibar];
            end
 
             [DET,FCC,OmegaK,GammaK,FK,OtherOutput,IRS]=fmmsre(P,A,B,C,R);
DET_peg_1=DET;
FCC_1=FCC;
fp_peg_1=max([max(max(OmegaK{1,1}-(eye(n)-A{1,1}*(p11*OmegaK{1,1}+p12*OmegaK{2,1}))\B{1,1})),max(max(OmegaK{2,1}-(eye(n)-A{2,1}*(p21*OmegaK{1,1}+p22*OmegaK{2,1}))\B{2,1}))]);           
    Estab1_mat=[p11*kron(OmegaK{1,1}',FK{1,1}) p12*kron(OmegaK{1,1}',FK{1,1});...
                p21*kron(OmegaK{2,1}',FK{2,1}) p22*kron(OmegaK{2,1}',FK{2,1})];
    Estab2_mat=[p11*FK{1,1} p12*FK{1,1};...
                p21*FK{2,1} p22*FK{2,1}];
    Estab_1=max([max(abs(eig(Estab1_mat))),max(abs(eig(Estab2_mat)))]);   %IE-stability involves spectral radius; not real value 
           
 
for t=1:Tstar-tstar
Omeg{1}(:,:,Tstar+1-t)=(eye(n)-A{1,1}*(p11*Omeg{1}(:,:,Tstar+2-t)+p12*Omeg{2}(:,:,Tstar+2-t)))\B{1,1};
Omeg{2}(:,:,Tstar+1-t)=(eye(n)-A{2,1}*(p21*Omeg{1}(:,:,Tstar+2-t)+p22*Omeg{2}(:,:,Tstar+2-t)))\B{2,1};
 
Ct{1}(:,:,Tstar+1-t)=(eye(n)-A{1,1}*(p11*Omeg{1}(:,:,Tstar+2-t)+p12*Omeg{2}(:,:,Tstar+2-t)))\(gam1{1}+A{1,1}*(p11*Ct{1}(:,:,Tstar+2-t)+p12*Ct{2}(:,:,Tstar+2-t)));
Ct{2}(:,:,Tstar+1-t)=(eye(n)-A{2,1}*(p21*Omeg{1}(:,:,Tstar+2-t)+p22*Omeg{2}(:,:,Tstar+2-t)))\(gam1{2}+A{2,1}*(p21*Ct{1}(:,:,Tstar+2-t)+p22*Ct{2}(:,:,Tstar+2-t)));
end
 
 
%Pre-FG
 
            for j=1:S, 
                B1{j,1}=[1 -kappa 0 0;...
                    0 1 0 0;...
                    (1/beta) 0 1 1-rho+gamma{j}*beta*rho;...
                    0 0 0 1];
                 
                A1{j}=[beta 0 0 0;...
                         sig 1 0 0;...
                         0 0 0 0;...
                         0 0 0 beta*rho];
                B2{j}=[zeros(2,4);...
                      0 0 (1/beta)-gamma{j} 0;...
                      0 0 0 0];
                   
                   
                   
                A{j,1}=B1{j}\A1{j}; 
                B{j,1}=B1{j}\B2{j}; 
                C{j,1}=B1{j}\C1; 
                gam2{j}=B1{j}\[0;0;0;0];
            end
 
for t=Tstar-tstar+1:Tstar
Omeg{1}(:,:,Tstar+1-t)=(eye(n)-A{1,1}*(p11*Omeg{1}(:,:,Tstar+2-t)+p12*Omeg{2}(:,:,Tstar+2-t)))\B{1,1};
Omeg{2}(:,:,Tstar+1-t)=(eye(n)-A{2,1}*(p21*Omeg{1}(:,:,Tstar+2-t)+p22*Omeg{2}(:,:,Tstar+2-t)))\B{2,1};
 
Ct{1}(:,:,Tstar+1-t)=(eye(n)-A{1,1}*(p11*Omeg{1}(:,:,Tstar+2-t)+p12*Omeg{2}(:,:,Tstar+2-t)))\(gam2{1}+A{1,1}*(p11*Ct{1}(:,:,Tstar+2-t)+p12*Ct{2}(:,:,Tstar+2-t)));
Ct{2}(:,:,Tstar+1-t)=(eye(n)-A{2,1}*(p21*Omeg{1}(:,:,Tstar+2-t)+p22*Omeg{2}(:,:,Tstar+2-t)))\(gam2{2}+A{2,1}*(p21*Ct{1}(:,:,Tstar+2-t)+p22*Ct{2}(:,:,Tstar+2-t)));
end
 
 
 
%Yb: Impulse response--gives initial responses across horizons
Yb1=zeros(n,1,Tstar+1);
 
for h=1:Tstar
Yb1(:,:,h+1)=Ct{1}(:,:,Tstar-h+2);
end
 
% figure(6)
% subplot(2,3,1)
% line([0 Tstar-1],[0 0],'Color','black','LineStyle','-')
% plot(0:Tstar-1,squeeze(Yb1(1,:,2:Tstar+1)),'b')
% ylabel('Initial Inflation')
% xlabel('T')
% title('Parameterization A') 
% hold on
% subplot(2,3,4)
% line([0 Tstar-1],[0 0],'Color','black','LineStyle','-')
% plot(0:Tstar-1,squeeze(Yb1(2,:,2:Tstar+1)),'b')
% ylabel('Initial Output')
% xlabel('T')
% hold on
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
%% Indet E-unstable low lambda
 
Tstar=1000;
tstar=Tstar-1;
 
Omeg{1}=zeros(n,n,Tstar+1);
Omeg{2}=zeros(n,n,Tstar+1);
Ct{1}=zeros(n,1,Tstar+1);
Ct{2}=zeros(n,1,Tstar+1);
 
    
    gamma{1}=.06;
    gamma{2}=-.05;
     
     
    % RE Solutions
             
            for j=1:S, 
                B1{j,1}=[1 -kappa 0 0;...
                    sig*phi{j} 1 0 0;...
                    (1/beta) 0 1 1-rho+gamma{j}*beta*rho;...
                    phi{j} 0 0 1];
                 
                A1{j}=[beta 0 0 0;...
                         sig 1 0 0;...
                         0 0 0 0;...
                         0 0 0 beta*rho];
                B2{j}=[zeros(2,4);...
                      0 0 (1/beta)-gamma{j} 0;...
                      0 0 0 0];
                   
                   
                A{j,1}=B1{j}\A1{j}; 
                B{j,1}=B1{j}\B2{j}; 
                C{j,1}=B1{j}\C1;                   
            end
             
             [DET,FCC,OmegaK,GammaK,FK,OtherOutput,IRS]=fmmsre(P,A,B,C,R);
DET2=DET;
FCC2=FCC;
             
fp2=max([max(max(OmegaK{1,1}-(eye(n)-A{1,1}*(p11*OmegaK{1,1}+p12*OmegaK{2,1}))\B{1,1})),max(max(OmegaK{2,1}-(eye(n)-A{2,1}*(p21*OmegaK{1,1}+p22*OmegaK{2,1}))\B{2,1}))]);
 
 
Omeg{1}(:,:,Tstar+1)=OmegaK{1,1};
Ct{1}(:,:,Tstar+1)=zeros(4,1);
Omeg{2}(:,:,Tstar+1)=OmegaK{2,1};
Ct{2}(:,:,Tstar+1)=zeros(4,1);
 
% FG Horizon
 
            for j=1:S, 
                B1{j,1}=[1 -kappa 0 0;...
                    0 1 0 0;...
                    (1/beta) 0 1 1-rho+gamma{j}*beta*rho;...
                    0 0 0 1];
                 
                A1{j}=[beta 0 0 0;...
                         sig 1 0 0;...
                         0 0 0 0;...
                         0 0 0 beta*rho];
                B2{j}=[zeros(2,4);...
                      0 0 (1/beta)-gamma{j} 0;...
                      0 0 0 0];
                   
                   
                A{j,1}=B1{j}\A1{j}; 
                B{j,1}=B1{j}\B2{j}; 
                C{j,1}=B1{j}\C1;   
                gam1{j}=B1{j}\[0;-sig*ibar;0;-ibar];
            end
 
               [DET,FCC,OmegaK,GammaK,FK,OtherOutput,IRS]=fmmsre(P,A,B,C,R);
DET_peg_2=DET;
FCC_2=FCC;
fp_peg_2=max([max(max(OmegaK{1,1}-(eye(n)-A{1,1}*(p11*OmegaK{1,1}+p12*OmegaK{2,1}))\B{1,1})),max(max(OmegaK{2,1}-(eye(n)-A{2,1}*(p21*OmegaK{1,1}+p22*OmegaK{2,1}))\B{2,1}))]);           
    Estab1_mat=[p11*kron(OmegaK{1,1}',FK{1,1}) p12*kron(OmegaK{1,1}',FK{1,1});...
                p21*kron(OmegaK{2,1}',FK{2,1}) p22*kron(OmegaK{2,1}',FK{2,1})];
    Estab2_mat=[p11*FK{1,1} p12*FK{1,1};...
                p21*FK{2,1} p22*FK{2,1}];
    Estab_2=max([max(abs(eig(Estab1_mat))),max(abs(eig(Estab2_mat)))]);   %IE-stability involves spectral radius; not real value 
           
 
for t=1:Tstar-tstar
Omeg{1}(:,:,Tstar+1-t)=(eye(n)-A{1,1}*(p11*Omeg{1}(:,:,Tstar+2-t)+p12*Omeg{2}(:,:,Tstar+2-t)))\B{1,1};
Omeg{2}(:,:,Tstar+1-t)=(eye(n)-A{2,1}*(p21*Omeg{1}(:,:,Tstar+2-t)+p22*Omeg{2}(:,:,Tstar+2-t)))\B{2,1};
 
Ct{1}(:,:,Tstar+1-t)=(eye(n)-A{1,1}*(p11*Omeg{1}(:,:,Tstar+2-t)+p12*Omeg{2}(:,:,Tstar+2-t)))\(gam1{1}+A{1,1}*(p11*Ct{1}(:,:,Tstar+2-t)+p12*Ct{2}(:,:,Tstar+2-t)));
Ct{2}(:,:,Tstar+1-t)=(eye(n)-A{2,1}*(p21*Omeg{1}(:,:,Tstar+2-t)+p22*Omeg{2}(:,:,Tstar+2-t)))\(gam1{2}+A{2,1}*(p21*Ct{1}(:,:,Tstar+2-t)+p22*Ct{2}(:,:,Tstar+2-t)));
end
 
 
%Pre-FG
 
            for j=1:S, 
                B1{j,1}=[1 -kappa 0 0;...
                    0 1 0 0;...
                    (1/beta) 0 1 1-rho+gamma{j}*beta*rho;...
                    0 0 0 1];
                 
                A1{j}=[beta 0 0 0;...
                         sig 1 0 0;...
                         0 0 0 0;...
                         0 0 0 beta*rho];
                B2{j}=[zeros(2,4);...
                      0 0 (1/beta)-gamma{j} 0;...
                      0 0 0 0];
                   
                   
                   
                A{j,1}=B1{j}\A1{j}; 
                B{j,1}=B1{j}\B2{j}; 
                C{j,1}=B1{j}\C1; 
                gam2{j}=B1{j}\[0;0;0;0];
            end
 
for t=Tstar-tstar+1:Tstar
Omeg{1}(:,:,Tstar+1-t)=(eye(n)-A{1,1}*(p11*Omeg{1}(:,:,Tstar+2-t)+p12*Omeg{2}(:,:,Tstar+2-t)))\B{1,1};
Omeg{2}(:,:,Tstar+1-t)=(eye(n)-A{2,1}*(p21*Omeg{1}(:,:,Tstar+2-t)+p22*Omeg{2}(:,:,Tstar+2-t)))\B{2,1};
 
Ct{1}(:,:,Tstar+1-t)=(eye(n)-A{1,1}*(p11*Omeg{1}(:,:,Tstar+2-t)+p12*Omeg{2}(:,:,Tstar+2-t)))\(gam2{1}+A{1,1}*(p11*Ct{1}(:,:,Tstar+2-t)+p12*Ct{2}(:,:,Tstar+2-t)));
Ct{2}(:,:,Tstar+1-t)=(eye(n)-A{2,1}*(p21*Omeg{1}(:,:,Tstar+2-t)+p22*Omeg{2}(:,:,Tstar+2-t)))\(gam2{2}+A{2,1}*(p21*Ct{1}(:,:,Tstar+2-t)+p22*Ct{2}(:,:,Tstar+2-t)));
end
 
 
 
%Yb: Impulse response--gives initial responses across horizons!
Yb2=zeros(n,1,Tstar+1);
 
for h=1:Tstar
Yb2(:,:,h+1)=Ct{1}(:,:,Tstar-h+2);
end
 
% figure(6)
% subplot(2,3,2)
% plot(0:Tstar-1,squeeze(Yb2(1,:,2:Tstar+1)),'-.r')
% hold on
% plot(0:Tstar-1,squeeze(Yb1(1,:,2:Tstar+1)),'b')
% xlabel('T')
% title('Parameterizations A and B') 
% hold on
% subplot(2,3,5)
% plot(0:Tstar-1,squeeze(Yb2(2,:,2:Tstar+1)),'-.r')
% hold on
% plot(0:Tstar-1,squeeze(Yb1(2,:,2:Tstar+1)),'b')
% xlabel('T')
% hold on
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
%% Indet E-unstable high lambda
 
Tstar=100;
tstar=Tstar-1;
 
Omeg{1}=zeros(n,n,Tstar+1);
Omeg{2}=zeros(n,n,Tstar+1);
Ct{1}=zeros(n,1,Tstar+1);
Ct{2}=zeros(n,1,Tstar+1);
 
    
    gamma{1}=.06;
    gamma{2}=-.02;
     
     
    % RE Solutions
             
            for j=1:S, 
                B1{j,1}=[1 -kappa 0 0;...
                    sig*phi{j} 1 0 0;...
                    (1/beta) 0 1 1-rho+gamma{j}*beta*rho;...
                    phi{j} 0 0 1];
                 
                A1{j}=[beta 0 0 0;...
                         sig 1 0 0;...
                         0 0 0 0;...
                         0 0 0 beta*rho];
                B2{j}=[zeros(2,4);...
                      0 0 (1/beta)-gamma{j} 0;...
                      0 0 0 0];
                   
                   
                A{j,1}=B1{j}\A1{j}; 
                B{j,1}=B1{j}\B2{j}; 
                C{j,1}=B1{j}\C1;                   
            end
             
              [DET,FCC,OmegaK,GammaK,FK,OtherOutput,IRS]=fmmsre(P,A,B,C,R);
DET3=DET;
FCC3=FCC;
             
fp3=max([max(max(OmegaK{1,1}-(eye(n)-A{1,1}*(p11*OmegaK{1,1}+p12*OmegaK{2,1}))\B{1,1})),max(max(OmegaK{2,1}-(eye(n)-A{2,1}*(p21*OmegaK{1,1}+p22*OmegaK{2,1}))\B{2,1}))]);
 
 
Omeg{1}(:,:,Tstar+1)=OmegaK{1,1};
Ct{1}(:,:,Tstar+1)=zeros(4,1);
Omeg{2}(:,:,Tstar+1)=OmegaK{2,1};
Ct{2}(:,:,Tstar+1)=zeros(4,1);
 
% FG Horizon
 
            for j=1:S, 
                B1{j,1}=[1 -kappa 0 0;...
                    0 1 0 0;...
                    (1/beta) 0 1 1-rho+gamma{j}*beta*rho;...
                    0 0 0 1];
                 
                A1{j}=[beta 0 0 0;...
                         sig 1 0 0;...
                         0 0 0 0;...
                         0 0 0 beta*rho];
                B2{j}=[zeros(2,4);...
                      0 0 (1/beta)-gamma{j} 0;...
                      0 0 0 0];
                   
                   
                A{j,1}=B1{j}\A1{j}; 
                B{j,1}=B1{j}\B2{j}; 
                C{j,1}=B1{j}\C1;   
                gam1{j}=B1{j}\[0;-sig*ibar;0;-ibar];
            end
 
             [DET,FCC,OmegaK,GammaK,FK,OtherOutput,IRS]=fmmsre(P,A,B,C,R);
DET_peg_3=DET;
FCC_3=FCC;
fp_peg_3=max([max(max(OmegaK{1,1}-(eye(n)-A{1,1}*(p11*OmegaK{1,1}+p12*OmegaK{2,1}))\B{1,1})),max(max(OmegaK{2,1}-(eye(n)-A{2,1}*(p21*OmegaK{1,1}+p22*OmegaK{2,1}))\B{2,1}))]);           
    Estab1_mat=[p11*kron(OmegaK{1,1}',FK{1,1}) p12*kron(OmegaK{1,1}',FK{1,1});...
                p21*kron(OmegaK{2,1}',FK{2,1}) p22*kron(OmegaK{2,1}',FK{2,1})];
    Estab2_mat=[p11*FK{1,1} p12*FK{1,1};...
                p21*FK{2,1} p22*FK{2,1}];
    Estab_3=max([max(abs(eig(Estab1_mat))),max(abs(eig(Estab2_mat)))]);  %IE-stability involves spectral radius; not real value 
           
 
for t=1:Tstar-tstar
Omeg{1}(:,:,Tstar+1-t)=(eye(n)-A{1,1}*(p11*Omeg{1}(:,:,Tstar+2-t)+p12*Omeg{2}(:,:,Tstar+2-t)))\B{1,1};
Omeg{2}(:,:,Tstar+1-t)=(eye(n)-A{2,1}*(p21*Omeg{1}(:,:,Tstar+2-t)+p22*Omeg{2}(:,:,Tstar+2-t)))\B{2,1};
 
Ct{1}(:,:,Tstar+1-t)=(eye(n)-A{1,1}*(p11*Omeg{1}(:,:,Tstar+2-t)+p12*Omeg{2}(:,:,Tstar+2-t)))\(gam1{1}+A{1,1}*(p11*Ct{1}(:,:,Tstar+2-t)+p12*Ct{2}(:,:,Tstar+2-t)));
Ct{2}(:,:,Tstar+1-t)=(eye(n)-A{2,1}*(p21*Omeg{1}(:,:,Tstar+2-t)+p22*Omeg{2}(:,:,Tstar+2-t)))\(gam1{2}+A{2,1}*(p21*Ct{1}(:,:,Tstar+2-t)+p22*Ct{2}(:,:,Tstar+2-t)));
end
 
 
%Pre-FG
 
            for j=1:S, 
                B1{j,1}=[1 -kappa 0 0;...
                    0 1 0 0;...
                    (1/beta) 0 1 1-rho+gamma{j}*beta*rho;...
                    0 0 0 1];
                 
                A1{j}=[beta 0 0 0;...
                         sig 1 0 0;...
                         0 0 0 0;...
                         0 0 0 beta*rho];
                B2{j}=[zeros(2,4);...
                      0 0 (1/beta)-gamma{j} 0;...
                      0 0 0 0];
                   
                   
                   
                A{j,1}=B1{j}\A1{j}; 
                B{j,1}=B1{j}\B2{j}; 
                C{j,1}=B1{j}\C1; 
                gam2{j}=B1{j}\[0;0;0;0];
            end
 
for t=Tstar-tstar+1:Tstar
Omeg{1}(:,:,Tstar+1-t)=(eye(n)-A{1,1}*(p11*Omeg{1}(:,:,Tstar+2-t)+p12*Omeg{2}(:,:,Tstar+2-t)))\B{1,1};
Omeg{2}(:,:,Tstar+1-t)=(eye(n)-A{2,1}*(p21*Omeg{1}(:,:,Tstar+2-t)+p22*Omeg{2}(:,:,Tstar+2-t)))\B{2,1};
 
Ct{1}(:,:,Tstar+1-t)=(eye(n)-A{1,1}*(p11*Omeg{1}(:,:,Tstar+2-t)+p12*Omeg{2}(:,:,Tstar+2-t)))\(gam2{1}+A{1,1}*(p11*Ct{1}(:,:,Tstar+2-t)+p12*Ct{2}(:,:,Tstar+2-t)));
Ct{2}(:,:,Tstar+1-t)=(eye(n)-A{2,1}*(p21*Omeg{1}(:,:,Tstar+2-t)+p22*Omeg{2}(:,:,Tstar+2-t)))\(gam2{2}+A{2,1}*(p21*Ct{1}(:,:,Tstar+2-t)+p22*Ct{2}(:,:,Tstar+2-t)));
end
 
 
 
%Yb: Impulse response--gives initial responses across horizons!
Yb3=zeros(n,1,Tstar+1);
 
for h=1:Tstar
Yb3(:,:,h+1)=Ct{1}(:,:,Tstar-h+2);
end
 
figure(6)
subplot(2,3,3)
plot(0:Tstar-1,squeeze(Yb3(1,:,2:Tstar+1)),'--r')
hold on
plot(0:Tstar-1,squeeze(Yb2(1,:,2:Tstar+1)),'-.r')
hold on
plot(0:Tstar-1,squeeze(Yb1(1,:,2:Tstar+1)),'b')
xlabel('T')
title('Parameterizations A, B, C') 
hold on
subplot(2,3,6)
plot(0:Tstar-1,squeeze(Yb3(2,:,2:Tstar+1)),'--r')
hold on
plot(0:Tstar-1,squeeze(Yb2(1,:,2:Tstar+1)),'-.r')
hold on
plot(0:Tstar-1,squeeze(Yb1(1,:,2:Tstar+1)),'b')
xlabel('T')
hold on
 
 
 
%% New Figures
figure(7)
plot(0:Tstar-1,squeeze(Yb3(1,:,2:Tstar+1))*400,'--b','LineWidth',2)
hold on
plot(0:Tstar-1,squeeze(Yb2(1,:,2:Tstar+1))*400,'-.k','LineWidth',2)
hold on
plot(0:Tstar-1,squeeze(Yb1(1,:,2:Tstar+1))*400,'r','LineWidth',2)

set(gca,...
    'XTickLabel',{'0' '20' '40' '60' '80' '100'},...
    'XTick',[0 20 40 60 80 100],'FontSize',16,'FontName', 'Times',...
    'YTickLabel',{'0' '0.5' '1' '1.5'},...
    'YTick',[0 0.5 1 1.5],'FontSize',16,'FontName', 'Times');
 set(gcf,'position',[10,10,500,360])
xlabel('\Delta_p','FontName', 'Times New Roman','FontSize',16)
ylabel('Inflation','FontName', 'Times New Roman','FontSize',16)
legend("C", "B", "A",'FontName', 'Times New Roman')
 
figure(8)
plot(0:Tstar-1,squeeze(Yb3(2,:,2:Tstar+1))*100,'--b','LineWidth',4)
hold on
plot(0:Tstar-1,squeeze(Yb2(2,:,2:Tstar+1))*100,'-.k','LineWidth',4)
hold on
plot(0:Tstar-1,squeeze(Yb1(2,:,2:Tstar+1))*100,'r','LineWidth',4)
xlabel('\Delta_p','FontName', 'Times New Roman','FontSize',16)
ylabel('Output Gap','FontName', 'Times New Roman','FontSize',16)