%Check: 3.1.2022

clear;
clc;
addpath('Functions')
tic 

%outside of loops
    S=2;
    p11=1;
    p12=1-p11;
    beta=.99; 
    sigma=.2;
    kappa=.11;
    
    phi{1}=1.5;
    phiy{1}=0;
    phiy{2}=0;
    phi{2}=0;  
    C1=zeros(2);
    R=zeros(2); 
    Z=[];
 
FP=[];
FPline=[];


for p22=0:.0002:1 %p22 is xi.
   
    p21=1-p22;
    P=[p11 p12;p21 p22];   
 

            for j=1:S, 
                B1{j,1}=[1 sigma*(1+phi{j});...
                       -kappa/(1+beta) 1];
                
                A1{j}=[1 sigma;...
                   0 beta/(1+beta)];
                    
                B2{j}=[0 0;...
                       0 1/(1+beta)];
                  
                A{j,1}=B1{j}\A1{j}; 
                B{j,1}=B1{j}\B2{j}; 
                C{j,1}=B1{j}\C1;   
            end
            
    [DET,FCC,OmegaK,GammaK,FK,OtherOutput,IRS]=fmmsre(P,A,B,C,R);
    Estab1_mat=[p11*kron(OmegaK{1,1}',FK{1,1}) p12*kron(OmegaK{1,1}',FK{1,2});...
                p21*kron(OmegaK{2,1}',FK{2,1}) p22*kron(OmegaK{2,1}',FK{2,2})];
    Estab2_mat=[p11*FK{1,1} p12*FK{1,2};...
                p21*FK{2,1} p22*FK{2,2}];   %Psi_F
    IEstab=max([max(abs(eig(Estab1_mat))),max(abs(eig(Estab2_mat)))]);
    
    FP=[FP; IEstab];
    FPline=[FPline; 1];
end

   
 FPIT=[];
for p22=0:.0002:1 %p22 is xi.
   
    p21=1-p22;
    P=[p11 p12;p21 p22];   
 

            for j=1:S, 
                B1{j,1}=[1 sigma*phi{j};...
                       -kappa 1];
                
                A1{j}=[1 sigma;...
                   0 beta];
                    
                B2{j}=zeros(2);
                  
                A{j,1}=B1{j}\A1{j}; 
                B{j,1}=B1{j}\B2{j}; 
                C{j,1}=B1{j}\C1;   
            end
            
    [DET,FCC,OmegaK,GammaK,FK,OtherOutput,IRS]=fmmsre(P,A,B,C,R);
    Estab1_mat=[p11*kron(OmegaK{1,1}',FK{1,1}) p12*kron(OmegaK{1,1}',FK{1,2});...
                p21*kron(OmegaK{2,1}',FK{2,1}) p22*kron(OmegaK{2,1}',FK{2,2})];
    Estab2_mat=[p11*FK{1,1} p12*FK{1,2};...
                p21*FK{2,1} p22*FK{2,2}];   %Psi_F
    IEstab=max([max(abs(eig(Estab1_mat))),max(abs(eig(Estab2_mat)))]);
    
    FPIT=[FPIT; IEstab];
   end


%%
figure(3)
plot(FP(:,1),'-.r','LineWidth',1.75)
hold on
plot(FPIT(:,1),'-.b','LineWidth',1.75)
hold on
plot(FPline(:,1),'--k','LineWidth',1)



%axis([.75 1 0 .2])
xlim([0 5001])
ylim([.8 1.2])
box on
% line([0 3],[1 1],'Color','black','LineStyle','--','LineWidth',1.2);
% line([1 1],[0 1.5],'Color','black','LineStyle','--','LineWidth',1.2); 
set(gca,...
    'XTickLabel',{'0' '0.2' '0.4' '0.6' '0.8' '1'},...
    'XTick',[0 .2*5001 .4*5001 .6*5001 .8*5001 5001],'FontSize',12,'FontName', 'Times',...
    'YTickLabel',{ '.8' '1'},...
    'YTick',[.8 1],'FontSize',12,'FontName', 'Times');
set(gcf,'position',[10,10,500,350])
xlabel('\eta','FontSize',22,'FontName', 'Times')
ylabel('Largest Eigenvalue','FontSize',22,'FontName', 'Times')
%title('Price Level Targeting','FontSize',18,'FontName', 'Times','FontWeight','Normal')
legend('PLT','IT')






