(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.3' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     97420,       2572]
NotebookOptionsPosition[     92563,       2486]
NotebookOutlinePosition[     92995,       2503]
CellTagsIndexPosition[     92952,       2500]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"ClearAll", "[", "\"\<`*\>\"", "]"}], ";"}], "\[IndentingNewLine]",
   "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{
     RowBox[{"z", 
      RowBox[{"(", "t", ")"}]}], "=", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"x", 
        RowBox[{"(", "t", ")"}]}], ",", 
       RowBox[{"pi", 
        RowBox[{"(", "t", ")"}]}], ",", 
       RowBox[{"s", 
        RowBox[{"(", "t", ")"}]}], ",", 
       RowBox[{"piexp", 
        RowBox[{"(", 
         RowBox[{"t", "+", "1"}], ")"}]}]}], ")"}]}], ";", " ", 
    RowBox[{
     RowBox[{"A0", " ", "z", 
      RowBox[{"(", "t", ")"}]}], "=", " ", 
     RowBox[{
      RowBox[{"B0", " ", "E_tz", 
       RowBox[{"(", 
        RowBox[{"t", "+", "1"}], ")"}]}], "+", 
      RowBox[{"A1", " ", "z", 
       RowBox[{"(", 
        RowBox[{"t", "-", "1"}], ")"}]}]}]}]}], "*)"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"A0", " ", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"1", "+", 
        RowBox[{"\[Sigma]", " ", "\[Phi]y"}]}], ",", 
       RowBox[{"\[Sigma]", " ", "\[Phi]"}], ",", " ", "0", ",", "0"}], "}"}], 
     ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "\[Kappa]"}], ",", "1", ",", "0", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", 
       RowBox[{"-", "1"}], ",", "1", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "0", ",", "1"}], "}"}]}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"A1", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", 
       FractionBox["1", "\[Alpha]"], ",", 
       RowBox[{"-", "1"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}]}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"B0", " ", "=", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"1", ",", "\[Sigma]", ",", "0", ",", "0"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"0", ",", "\[Beta]", ",", "0", ",", "0"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"0", ",", "1", ",", "0", ",", "0"}], "}"}]}], "}"}]}], ";"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"D0", " ", "=", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", "0", "}"}], ",", 
       RowBox[{"{", "0", "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"-", "1"}], "}"}], ",", 
       RowBox[{"{", "0", "}"}]}], "}"}]}], ";"}], "*)"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Abar", " ", "=", " ", 
   RowBox[{
    RowBox[{"Inverse", "[", "A0", "]"}], ".", "A1"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Bbar", " ", "=", " ", 
    RowBox[{
     RowBox[{
      RowBox[{"Inverse", "[", "A0", "]"}], ".", "B0"}], " ", "//", 
     "Simplify"}]}], ";"}], "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Solutions", "=", 
    RowBox[{
     RowBox[{"Solve", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"b11", ",", "b12", ",", "b13", ",", "b14"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"b21", ",", "b22", ",", "b23", ",", "b24"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"b31", ",", "b32", ",", "b33", ",", "b34"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"b41", ",", "b42", ",", "b43", ",", "b44"}], "}"}]}], 
         "}"}], "\[Equal]", 
        RowBox[{
         RowBox[{"Inverse", "[", 
          RowBox[{
           RowBox[{"IdentityMatrix", "[", "4", "]"}], "-", 
           RowBox[{"Bbar", ".", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"b11", ",", "b12", ",", "b13", ",", "b14"}], "}"}], 
              ",", 
              RowBox[{"{", 
               RowBox[{"b21", ",", "b22", ",", "b23", ",", "b24"}], "}"}], 
              ",", 
              RowBox[{"{", 
               RowBox[{"b31", ",", "b32", ",", "b33", ",", "b34"}], "}"}], 
              ",", 
              RowBox[{"{", 
               RowBox[{"b41", ",", "b42", ",", "b43", ",", "b44"}], "}"}]}], 
             "}"}]}]}], "]"}], ".", "Abar"}]}], ",", 
       RowBox[{"{", 
        RowBox[{
        "b11", ",", "b12", ",", "b13", ",", "b14", ",", "b21", ",", "b22", 
         ",", "b23", ",", "b24", ",", "b31", ",", "b32", ",", "b33", ",", 
         "b34", ",", "b41", ",", "b42", ",", "b43", ",", "b44"}], "}"}]}], 
      "]"}], "//", "Simplify"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{"Bpost", "=", 
  RowBox[{"FullSimplify", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"b11", ",", "b12", ",", "b13", ",", "b14"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"b21", ",", "b22", ",", "b23", ",", "b24"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"b31", ",", "b32", ",", "b33", ",", "b34"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"b41", ",", "b42", ",", "b43", ",", "b44"}], "}"}]}], "}"}], "/.", 
     RowBox[{"Solutions", "[", 
      RowBox[{"[", "2", "]"}], "]"}]}], ",", 
    RowBox[{
     RowBox[{"\[Alpha]", ">", "0"}], "&&", 
     RowBox[{"\[Beta]", ">", "0"}], "&&", 
     RowBox[{"\[Sigma]", ">", "0"}], "&&", " ", 
     RowBox[{"\[Kappa]", ">", "0"}]}]}], 
   "]"}]}], "\[IndentingNewLine]"}], "Input",
 CellChangeTimes->{{3.8150941993463387`*^9, 3.8150943267791557`*^9}, {
  3.8150950867093334`*^9, 3.815095087154022*^9}, {3.8150952784777827`*^9, 
  3.8150952802497606`*^9}, {3.8150973794128056`*^9, 3.815097379838676*^9}, {
  3.8150977388439846`*^9, 3.815097740409824*^9}, {3.8156949875125427`*^9, 
  3.815695045205718*^9}, {3.8156969655992813`*^9, 3.8156969898677154`*^9}, {
  3.8156990151789856`*^9, 3.815699022456169*^9}, {3.8161131239914136`*^9, 
  3.8161131654598994`*^9}, {3.8166613924049454`*^9, 3.8166614433918285`*^9}, {
  3.8166662051760864`*^9, 3.8166662395961294`*^9}, {3.8198615685555744`*^9, 
  3.819861632966071*^9}},
 CellLabel->
  "In[118]:=",ExpressionUUID->"11915e7c-9506-4e99-8ec3-83dae53a0432"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"0", ",", "0", ",", 
     FractionBox[
      RowBox[{
       RowBox[{"-", "1"}], "+", "\[Beta]", "+", 
       RowBox[{"\[Kappa]", " ", "\[Sigma]"}], "+", 
       RowBox[{"\[Beta]", " ", "\[Sigma]", " ", "\[Phi]y"}], "-", 
       SqrtBox[
        RowBox[{
         RowBox[{
          RowBox[{"-", "4"}], " ", "\[Kappa]", " ", "\[Sigma]", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "1"}], "+", 
            RowBox[{"\[Beta]", " ", "\[Phi]"}]}], ")"}]}], "+", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "1"}], "+", "\[Beta]", "+", 
            RowBox[{"\[Kappa]", " ", "\[Sigma]"}], "+", 
            RowBox[{"\[Beta]", " ", "\[Sigma]", " ", "\[Phi]y"}]}], ")"}], 
          "2"]}]]}], 
      RowBox[{"2", " ", "\[Alpha]", " ", "\[Kappa]"}]], ",", 
     RowBox[{"-", 
      FractionBox[
       RowBox[{
        RowBox[{"-", "1"}], "+", "\[Beta]", "+", 
        RowBox[{"\[Kappa]", " ", "\[Sigma]"}], "+", 
        RowBox[{"\[Beta]", " ", "\[Sigma]", " ", "\[Phi]y"}], "-", 
        SqrtBox[
         RowBox[{
          RowBox[{
           RowBox[{"-", "4"}], " ", "\[Kappa]", " ", "\[Sigma]", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "1"}], "+", 
             RowBox[{"\[Beta]", " ", "\[Phi]"}]}], ")"}]}], "+", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "1"}], "+", "\[Beta]", "+", 
             RowBox[{"\[Kappa]", " ", "\[Sigma]"}], "+", 
             RowBox[{"\[Beta]", " ", "\[Sigma]", " ", "\[Phi]y"}]}], ")"}], 
           "2"]}]]}], 
       RowBox[{"2", " ", "\[Kappa]"}]]}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "0", ",", 
     RowBox[{"-", 
      FractionBox["1", "\[Alpha]"]}], ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "0", ",", 
     RowBox[{"-", 
      FractionBox[
       RowBox[{"1", "+", "\[Beta]", "+", 
        RowBox[{"\[Kappa]", " ", "\[Sigma]"}], "+", 
        RowBox[{"\[Beta]", " ", "\[Sigma]", " ", "\[Phi]y"}], "-", 
        SqrtBox[
         RowBox[{
          RowBox[{
           RowBox[{"-", "4"}], " ", "\[Kappa]", " ", "\[Sigma]", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "1"}], "+", 
             RowBox[{"\[Beta]", " ", "\[Phi]"}]}], ")"}]}], "+", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "1"}], "+", "\[Beta]", "+", 
             RowBox[{"\[Kappa]", " ", "\[Sigma]"}], "+", 
             RowBox[{"\[Beta]", " ", "\[Sigma]", " ", "\[Phi]y"}]}], ")"}], 
           "2"]}]]}], 
       RowBox[{"2", " ", "\[Alpha]", " ", "\[Beta]"}]]}], ",", 
     FractionBox[
      RowBox[{"1", "+", "\[Beta]", "+", 
       RowBox[{"\[Kappa]", " ", "\[Sigma]"}], "+", 
       RowBox[{"\[Beta]", " ", "\[Sigma]", " ", "\[Phi]y"}], "-", 
       SqrtBox[
        RowBox[{
         RowBox[{
          RowBox[{"-", "4"}], " ", "\[Kappa]", " ", "\[Sigma]", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "1"}], "+", 
            RowBox[{"\[Beta]", " ", "\[Phi]"}]}], ")"}]}], "+", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "1"}], "+", "\[Beta]", "+", 
            RowBox[{"\[Kappa]", " ", "\[Sigma]"}], "+", 
            RowBox[{"\[Beta]", " ", "\[Sigma]", " ", "\[Phi]y"}]}], ")"}], 
          "2"]}]]}], 
      RowBox[{"2", " ", "\[Beta]"}]]}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.8166662449528284`*^9, 3.81666914376567*^9, 
  3.816669761120967*^9, 3.8195176600084486`*^9, 3.8195179940422707`*^9, 
  3.8195199921004133`*^9, 3.8195203138233833`*^9, 3.819525743966095*^9, 
  3.819861693270609*^9, 3.819866044502303*^9, 3.819867848111583*^9},
 CellLabel->
  "Out[125]=",ExpressionUUID->"a47bf44a-64b6-4c02-98c7-4aed8bbc184c"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"MatrixForm", "[", "Bpost", "]"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]"}]}]], "Input",
 CellChangeTimes->{{3.816661557921747*^9, 3.8166616032574363`*^9}, {
   3.816661694042486*^9, 3.8166617280063267`*^9}, 3.8166624971440787`*^9, {
   3.816666132009251*^9, 3.816666140954367*^9}},
 CellLabel->
  "In[126]:=",ExpressionUUID->"fd91ec4f-cc4d-4ffb-a2df-393141d49262"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0", "0", 
      FractionBox[
       RowBox[{
        RowBox[{"-", "1"}], "+", "\[Beta]", "+", 
        RowBox[{"\[Kappa]", " ", "\[Sigma]"}], "+", 
        RowBox[{"\[Beta]", " ", "\[Sigma]", " ", "\[Phi]y"}], "-", 
        SqrtBox[
         RowBox[{
          RowBox[{
           RowBox[{"-", "4"}], " ", "\[Kappa]", " ", "\[Sigma]", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "1"}], "+", 
             RowBox[{"\[Beta]", " ", "\[Phi]"}]}], ")"}]}], "+", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "1"}], "+", "\[Beta]", "+", 
             RowBox[{"\[Kappa]", " ", "\[Sigma]"}], "+", 
             RowBox[{"\[Beta]", " ", "\[Sigma]", " ", "\[Phi]y"}]}], ")"}], 
           "2"]}]]}], 
       RowBox[{"2", " ", "\[Alpha]", " ", "\[Kappa]"}]], 
      RowBox[{"-", 
       FractionBox[
        RowBox[{
         RowBox[{"-", "1"}], "+", "\[Beta]", "+", 
         RowBox[{"\[Kappa]", " ", "\[Sigma]"}], "+", 
         RowBox[{"\[Beta]", " ", "\[Sigma]", " ", "\[Phi]y"}], "-", 
         SqrtBox[
          RowBox[{
           RowBox[{
            RowBox[{"-", "4"}], " ", "\[Kappa]", " ", "\[Sigma]", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "1"}], "+", 
              RowBox[{"\[Beta]", " ", "\[Phi]"}]}], ")"}]}], "+", 
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "1"}], "+", "\[Beta]", "+", 
              RowBox[{"\[Kappa]", " ", "\[Sigma]"}], "+", 
              RowBox[{"\[Beta]", " ", "\[Sigma]", " ", "\[Phi]y"}]}], ")"}], 
            "2"]}]]}], 
        RowBox[{"2", " ", "\[Kappa]"}]]}]},
     {"0", "0", 
      RowBox[{"-", 
       FractionBox["1", "\[Alpha]"]}], "1"},
     {"0", "0", "0", "0"},
     {"0", "0", 
      RowBox[{"-", 
       FractionBox[
        RowBox[{"1", "+", "\[Beta]", "+", 
         RowBox[{"\[Kappa]", " ", "\[Sigma]"}], "+", 
         RowBox[{"\[Beta]", " ", "\[Sigma]", " ", "\[Phi]y"}], "-", 
         SqrtBox[
          RowBox[{
           RowBox[{
            RowBox[{"-", "4"}], " ", "\[Kappa]", " ", "\[Sigma]", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "1"}], "+", 
              RowBox[{"\[Beta]", " ", "\[Phi]"}]}], ")"}]}], "+", 
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "1"}], "+", "\[Beta]", "+", 
              RowBox[{"\[Kappa]", " ", "\[Sigma]"}], "+", 
              RowBox[{"\[Beta]", " ", "\[Sigma]", " ", "\[Phi]y"}]}], ")"}], 
            "2"]}]]}], 
        RowBox[{"2", " ", "\[Alpha]", " ", "\[Beta]"}]]}], 
      FractionBox[
       RowBox[{"1", "+", "\[Beta]", "+", 
        RowBox[{"\[Kappa]", " ", "\[Sigma]"}], "+", 
        RowBox[{"\[Beta]", " ", "\[Sigma]", " ", "\[Phi]y"}], "-", 
        SqrtBox[
         RowBox[{
          RowBox[{
           RowBox[{"-", "4"}], " ", "\[Kappa]", " ", "\[Sigma]", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "1"}], "+", 
             RowBox[{"\[Beta]", " ", "\[Phi]"}]}], ")"}]}], "+", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "1"}], "+", "\[Beta]", "+", 
             RowBox[{"\[Kappa]", " ", "\[Sigma]"}], "+", 
             RowBox[{"\[Beta]", " ", "\[Sigma]", " ", "\[Phi]y"}]}], ")"}], 
           "2"]}]]}], 
       RowBox[{"2", " ", "\[Beta]"}]]}
    },
    GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Baseline}}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{
  3.8166662481443005`*^9, {3.8166691498339443`*^9, 3.8166691627018766`*^9}, 
   3.8195176684281793`*^9, 3.8195179984116964`*^9, 3.8195199977293835`*^9, 
   3.8195203163336744`*^9, 3.819525746730685*^9, 3.8198617198997116`*^9, 
   3.8198660499084125`*^9, 3.819867851969301*^9},
 CellLabel->
  "Out[126]//MatrixForm=",ExpressionUUID->"b941a2e9-a608-4c01-9bd6-\
f8954236181a"]
}, Open  ]],

Cell[BoxData[""], "Input",
 CellChangeTimes->{{3.819865603410264*^9, 
  3.8198656044454975`*^9}},ExpressionUUID->"03160197-4c9d-444b-8b1a-\
445347603cbe"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"psi", "=", 
   FractionBox[
    RowBox[{"1", "+", "\[Beta]", "+", 
     RowBox[{"\[Kappa]", " ", "\[Sigma]"}], "+", 
     RowBox[{"\[Beta]", " ", "\[Sigma]", " ", "\[Phi]y"}], "-", 
     SqrtBox[
      RowBox[{
       RowBox[{
        RowBox[{"-", "4"}], " ", "\[Kappa]", " ", "\[Sigma]", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "1"}], "+", 
          RowBox[{"\[Beta]", " ", "\[Phi]"}]}], ")"}]}], "+", 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "1"}], "+", "\[Beta]", "+", 
          RowBox[{"\[Kappa]", " ", "\[Sigma]"}], "+", 
          RowBox[{"\[Beta]", " ", "\[Sigma]", " ", "\[Phi]y"}]}], ")"}], 
        "2"]}]]}], 
    RowBox[{"2", " ", "\[Beta]"}]]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"psiy", "=", 
   RowBox[{"-", 
    FractionBox[
     RowBox[{
      RowBox[{"-", "1"}], "+", "\[Beta]", "+", 
      RowBox[{"\[Kappa]", " ", "\[Sigma]"}], "+", 
      RowBox[{"\[Beta]", " ", "\[Sigma]", " ", "\[Phi]y"}], "-", 
      SqrtBox[
       RowBox[{
        RowBox[{
         RowBox[{"-", "4"}], " ", "\[Kappa]", " ", "\[Sigma]", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "1"}], "+", 
           RowBox[{"\[Beta]", " ", "\[Phi]"}]}], ")"}]}], "+", 
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "1"}], "+", "\[Beta]", "+", 
           RowBox[{"\[Kappa]", " ", "\[Sigma]"}], "+", 
           RowBox[{"\[Beta]", " ", "\[Sigma]", " ", "\[Phi]y"}]}], ")"}], 
         "2"]}]]}], 
     RowBox[{"2", " ", "\[Kappa]"}]]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"FullSimplify", "[", 
  RowBox[{"psiy", "-", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"1", "-", 
      RowBox[{"\[Beta]", " ", "psi"}]}], ")"}], "/", "\[Kappa]"}]}], 
  "]"}]}], "Input",
 CellChangeTimes->{{3.816663074688876*^9, 3.81666313818932*^9}, {
  3.8166633600907707`*^9, 3.8166633783080883`*^9}, {3.8166634171651144`*^9, 
  3.8166634214631367`*^9}, {3.8166634795835514`*^9, 3.816663481445597*^9}, {
  3.8166662571158433`*^9, 3.816666270701539*^9}, {3.8166690846881704`*^9, 
  3.8166690901794777`*^9}, {3.816669309931072*^9, 3.8166693654813566`*^9}, {
  3.8166697815939245`*^9, 3.8166698233812504`*^9}, {3.8166699729144306`*^9, 
  3.8166699818700533`*^9}, {3.819517692836454*^9, 3.8195177021305127`*^9}, {
  3.8195200074763584`*^9, 3.8195200182216644`*^9}},
 CellLabel->
  "In[127]:=",ExpressionUUID->"6c1e0aa7-c4c2-4da7-a618-75619249ae79"],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{3.8198617542112975`*^9, 3.8198660962554913`*^9, 
  3.819867857008397*^9},
 CellLabel->
  "Out[129]=",ExpressionUUID->"9252847f-7af1-4d3b-b16d-4c95179afe2c"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
   "Here", " ", "we", " ", "show", " ", "psi", " ", "is", " ", "inside", " ", 
    "unit", " ", "circle"}], "*)"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"psi", "=", 
     FractionBox[
      RowBox[{"1", "+", "\[Beta]", "+", 
       RowBox[{"\[Kappa]", " ", "\[Sigma]"}], "+", 
       RowBox[{"\[Beta]", " ", "\[Sigma]", " ", "\[Phi]y"}], "-", 
       SqrtBox[
        RowBox[{
         RowBox[{
          RowBox[{"-", "4"}], " ", "\[Kappa]", " ", "\[Sigma]", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "1"}], "+", 
            RowBox[{"\[Beta]", " ", "\[Phi]"}]}], ")"}]}], "+", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "1"}], "+", "\[Beta]", "+", 
            RowBox[{"\[Kappa]", " ", "\[Sigma]"}], "+", 
            RowBox[{"\[Beta]", " ", "\[Sigma]", " ", "\[Phi]y"}]}], ")"}], 
          "2"]}]]}], 
      RowBox[{"2", " ", "\[Beta]"}]]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"psialt", "=", 
     FractionBox[
      RowBox[{"1", "+", "\[Beta]", "+", 
       RowBox[{"\[Kappa]", " ", "\[Sigma]"}], "+", 
       RowBox[{"\[Beta]", " ", "\[Sigma]", " ", "\[Phi]y"}], "+", 
       SqrtBox[
        RowBox[{
         RowBox[{
          RowBox[{"-", "4"}], " ", "\[Kappa]", " ", "\[Sigma]", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "1"}], "+", 
            RowBox[{"\[Beta]", " ", "\[Phi]"}]}], ")"}]}], "+", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "1"}], "+", "\[Beta]", "+", 
            RowBox[{"\[Kappa]", " ", "\[Sigma]"}], "+", 
            RowBox[{"\[Beta]", " ", "\[Sigma]", " ", "\[Phi]y"}]}], ")"}], 
          "2"]}]]}], 
      RowBox[{"2", " ", "\[Beta]"}]]}], ";"}], "\n", 
   RowBox[{"(*", 
    RowBox[{
    "psi", " ", "and", " ", "psialt", " ", "are", " ", "the", " ", "roots", 
     " ", "of", " ", "the", " ", "following", " ", 
     RowBox[{"quadratic", ":", " ", 
      RowBox[{
       SuperscriptBox["x", "2"], "+", 
       FractionBox[
        RowBox[{"1", "+", 
         RowBox[{"\[Kappa]", " ", "\[Sigma]", " ", "\[Phi]"}], "+", 
         RowBox[{"\[Sigma]", " ", "\[Phi]y"}]}], "\[Beta]"], "+", 
       FractionBox[
        RowBox[{"x", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "1"}], "-", "\[Beta]", "-", 
           RowBox[{"\[Kappa]", " ", "\[Sigma]"}], "-", 
           RowBox[{"\[Beta]", " ", "\[Sigma]", " ", "\[Phi]y"}]}], ")"}]}], 
        "\[Beta]"]}]}]}], "*)"}], "\n", 
   RowBox[{"Simplify", "[", 
    RowBox[{
     SuperscriptBox["psi", "2"], "+", 
     FractionBox[
      RowBox[{"1", "+", 
       RowBox[{"\[Kappa]", " ", "\[Sigma]", " ", "\[Phi]"}], "+", 
       RowBox[{"\[Sigma]", " ", "\[Phi]y"}]}], "\[Beta]"], "+", 
     FractionBox[
      RowBox[{"psi", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "1"}], "-", "\[Beta]", "-", 
         RowBox[{"\[Kappa]", " ", "\[Sigma]"}], "-", 
         RowBox[{"\[Beta]", " ", "\[Sigma]", " ", "\[Phi]y"}]}], ")"}]}], 
      "\[Beta]"]}], "]"}], "\[IndentingNewLine]", 
   RowBox[{"Simplify", "[", 
    RowBox[{
     SuperscriptBox["psialt", "2"], "+", 
     FractionBox[
      RowBox[{"1", "+", 
       RowBox[{"\[Kappa]", " ", "\[Sigma]", " ", "\[Phi]"}], "+", 
       RowBox[{"\[Sigma]", " ", "\[Phi]y"}]}], "\[Beta]"], "+", 
     FractionBox[
      RowBox[{"psialt", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "1"}], "-", "\[Beta]", "-", 
         RowBox[{"\[Kappa]", " ", "\[Sigma]"}], "-", 
         RowBox[{"\[Beta]", " ", "\[Sigma]", " ", "\[Phi]y"}]}], ")"}]}], 
      "\[Beta]"]}], "]"}], "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
     RowBox[{
      RowBox[{
       SuperscriptBox["x", "2"], "+", 
       FractionBox[
        RowBox[{"1", "+", 
         RowBox[{"\[Kappa]", " ", "\[Sigma]", " ", "\[Phi]"}], "+", 
         RowBox[{"\[Sigma]", " ", "\[Phi]y"}]}], "\[Beta]"], "+", 
       FractionBox[
        RowBox[{"x", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "1"}], "-", "\[Beta]", "-", 
           RowBox[{"\[Kappa]", " ", "\[Sigma]"}], "-", 
           RowBox[{"\[Beta]", " ", "\[Sigma]", " ", "\[Phi]y"}]}], ")"}]}], 
        "\[Beta]"]}], "=", 
      RowBox[{
       SuperscriptBox["x", "2"], "+", "a0", "+", 
       RowBox[{"a1", " ", "x"}]}]}], ";"}], " ", "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"a1", "=", 
     RowBox[{"-", 
      FractionBox[
       RowBox[{"(", 
        RowBox[{"1", "+", "\[Beta]", "+", 
         RowBox[{"\[Kappa]", " ", "\[Sigma]"}], "+", 
         RowBox[{"\[Beta]", " ", "\[Sigma]", " ", "\[Phi]y"}]}], ")"}], 
       "\[Beta]"]}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"a0", "=", 
     FractionBox[
      RowBox[{"1", "+", 
       RowBox[{"\[Kappa]", " ", "\[Sigma]", " ", "\[Phi]"}], "+", 
       RowBox[{"\[Sigma]", " ", "\[Phi]y"}]}], "\[Beta]"]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"SC1", "=", 
    RowBox[{"Simplify", "[", 
     RowBox[{
      RowBox[{"a1", "^", "2"}], "-", 
      RowBox[{"4", " ", "a0"}]}], " ", "]"}]}], 
   RowBox[{"(*", 
    RowBox[{"SC1", "=", 
     RowBox[{
      RowBox[{
       RowBox[{"a1", "^", "2"}], "-", 
       RowBox[{"4", " ", "a0"}]}], ">", "0"}]}], " ", "*)"}], " ", 
   RowBox[{"(*", 
    RowBox[{
     RowBox[{
      RowBox[{"See", " ", "Schur"}], "-", 
      RowBox[{
      "Cohn", " ", "conditions", " ", "for", " ", "one", " ", "root", " ", 
       "inside"}]}], ",", " ", 
     RowBox[{
     "one", " ", "root", " ", "outside", " ", "unit", " ", "circle"}]}], 
    "*)"}], "\[IndentingNewLine]", 
   RowBox[{"SC2", "=", 
    RowBox[{"Simplify", "[", 
     RowBox[{
      RowBox[{"-", "a1"}], "-", "1", "-", "a0"}], "]"}], 
    RowBox[{"(*", 
     RowBox[{"SC2", "=", 
      RowBox[{
       RowBox[{"|", "a1", "|", 
        RowBox[{"-", 
         RowBox[{"|", 
          RowBox[{"1", "+", "a0"}], "|"}]}]}], "=", 
       RowBox[{
        RowBox[{
         RowBox[{"-", "a1"}], "-", "1", "-", "a0"}], ">", "0"}]}]}], "*)"}], 
    " "}]}]}]], "Input",
 CellChangeTimes->{{3.819867869449333*^9, 3.8198678726423345`*^9}},
 CellLabel->
  "In[130]:=",ExpressionUUID->"fbd3e788-3c9b-4109-b0c5-d63d086acfbd"],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{3.819866187689929*^9, 3.819867886930895*^9},
 CellLabel->
  "Out[132]=",ExpressionUUID->"632989b1-2091-48ac-af0d-65f6bb5f259e"],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{3.819866187689929*^9, 3.819867886939872*^9},
 CellLabel->
  "Out[133]=",ExpressionUUID->"4a0c7578-c0ba-42b8-8172-2c73fe2dda91"],

Cell[BoxData[
 FractionBox[
  RowBox[{
   RowBox[{
    RowBox[{"-", "4"}], " ", "\[Beta]", " ", 
    RowBox[{"(", 
     RowBox[{"1", "+", 
      RowBox[{"\[Kappa]", " ", "\[Sigma]", " ", "\[Phi]"}], "+", 
      RowBox[{"\[Sigma]", " ", "\[Phi]y"}]}], ")"}]}], "+", 
   SuperscriptBox[
    RowBox[{"(", 
     RowBox[{"1", "+", "\[Beta]", "+", 
      RowBox[{"\[Kappa]", " ", "\[Sigma]"}], "+", 
      RowBox[{"\[Beta]", " ", "\[Sigma]", " ", "\[Phi]y"}]}], ")"}], "2"]}], 
  SuperscriptBox["\[Beta]", "2"]]], "Output",
 CellChangeTimes->{3.819866187689929*^9, 3.8198678870366135`*^9},
 CellLabel->
  "Out[136]=",ExpressionUUID->"a896a011-a688-44a2-a785-e52f4397d075"],

Cell[BoxData[
 FractionBox[
  RowBox[{"\[Sigma]", " ", 
   RowBox[{"(", 
    RowBox[{"\[Kappa]", "-", 
     RowBox[{"\[Kappa]", " ", "\[Phi]"}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "1"}], "+", "\[Beta]"}], ")"}], " ", "\[Phi]y"}]}], 
    ")"}]}], "\[Beta]"]], "Output",
 CellChangeTimes->{3.819866187689929*^9, 3.8198678870425973`*^9},
 CellLabel->
  "Out[137]=",ExpressionUUID->"5bf51d5e-8e8c-492f-8f2b-b415308e288e"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\n", 
  RowBox[{"(*", 
   RowBox[{"Manually", " ", "Simplify", " ", "SC1"}], "*)"}], "\n", 
  RowBox[{
   RowBox[{"Expand", "[", 
    RowBox[{
     FractionBox[
      RowBox[{
       RowBox[{
        RowBox[{"-", "4"}], " ", "\[Beta]", " ", 
        RowBox[{"(", 
         RowBox[{"1", "+", 
          RowBox[{"\[Kappa]", " ", "\[Sigma]", " ", "\[Phi]"}], "+", 
          RowBox[{"\[Sigma]", " ", "\[Phi]y"}]}], ")"}]}], "+", 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"1", "+", "\[Beta]", "+", 
          RowBox[{"\[Kappa]", " ", "\[Sigma]"}], "+", 
          RowBox[{"\[Beta]", " ", "\[Sigma]", " ", "\[Phi]y"}]}], ")"}], 
        "2"]}], 
      SuperscriptBox["\[Beta]", "2"]], "-", 
     FractionBox[
      RowBox[{
       RowBox[{"4", " ", "\[Kappa]", " ", "\[Sigma]", " ", 
        RowBox[{"(", 
         RowBox[{"1", "-", 
          RowBox[{"\[Beta]", " ", "\[Phi]"}]}], ")"}]}], "+", 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "1"}], "+", "\[Beta]", "+", 
          RowBox[{"\[Kappa]", " ", "\[Sigma]"}], "+", 
          RowBox[{"\[Beta]", " ", "\[Sigma]", " ", "\[Phi]y"}]}], ")"}], 
        "2"]}], 
      SuperscriptBox["\[Beta]", "2"]]}], "]"}], " ", "\[IndentingNewLine]", 
   "\[IndentingNewLine]"}]}]], "Input",
 CellChangeTimes->{{3.8198656095897474`*^9, 3.819865857438986*^9}, {
   3.8198659489883113`*^9, 3.8198659497408075`*^9}, {3.8198659935240545`*^9, 
   3.819866030275214*^9}, {3.819866119993122*^9, 3.8198661342815213`*^9}, {
   3.819866205843531*^9, 3.8198662608372545`*^9}, 3.8198678975356083`*^9},
 CellLabel->
  "In[138]:=",ExpressionUUID->"63773ea2-0d7f-49c8-a3e9-5feeea369a15"],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{
  3.8198660324778357`*^9, {3.8198662441547728`*^9, 3.8198662615084553`*^9}, 
   3.819867899010668*^9},
 CellLabel->
  "Out[138]=",ExpressionUUID->"0139f3ac-b250-42c0-ad88-acde2386678d"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{"Manually", " ", "Simplify", " ", "SC1"}], "*)"}], "\n", 
  RowBox[{
   RowBox[{
    RowBox[{"SC1", "=", 
     FractionBox[
      RowBox[{
       RowBox[{"4", " ", "\[Kappa]", " ", "\[Sigma]", " ", 
        RowBox[{"(", 
         RowBox[{"1", "-", 
          RowBox[{"\[Beta]", " ", "\[Phi]"}]}], ")"}]}], "+", 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "1"}], "+", "\[Beta]", "+", 
          RowBox[{"\[Kappa]", " ", "\[Sigma]"}], "+", 
          RowBox[{"\[Beta]", " ", "\[Sigma]", " ", "\[Phi]y"}]}], ")"}], 
        "2"]}], 
      SuperscriptBox["\[Beta]", "2"]]}], ";", 
    RowBox[{"(*", 
     RowBox[{"SC1", ">", 
      RowBox[{"0", " ", "if", " ", "\[Phi]a"}], "<", "1."}], "*)"}], 
    "\[IndentingNewLine]", 
    RowBox[{"SC2", "=", 
     FractionBox[
      RowBox[{"\[Sigma]", " ", 
       RowBox[{"(", 
        RowBox[{"\[Kappa]", "-", 
         RowBox[{"\[Kappa]", " ", "\[Phi]"}], "+", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "1"}], "+", "\[Beta]"}], ")"}], " ", "\[Phi]y"}]}], 
        ")"}]}], "\[Beta]"]}], ";"}], 
   RowBox[{"(*", 
    RowBox[{"SC2", ">", 
     RowBox[{
      RowBox[{"0", " ", "iff", " ", "\[Kappa]"}], "-", 
      RowBox[{"\[Kappa]", " ", "\[Phi]a"}], "+", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "1"}], "+", "\[Beta]"}], ")"}], " ", "\[Phi]ya"}]}], 
     ">", 
     RowBox[{
      RowBox[{"0", " ", "iff", " ", "1"}], "-", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"1", "-", "\[Beta]"}], ")"}], "/", "k"}], ")"}], 
       "\[Phi]ya"}]}], " ", ">", " ", "\[Phi]a"}], "*)"}], " ", 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
     RowBox[{"Conclusion", ":", " ", 
      RowBox[{
      "since", " ", "psiunstable", " ", "is", " ", "outside", " ", "unit", 
       " ", "circle"}]}], ",", " ", 
     RowBox[{
     "and", " ", "SC", " ", "conditions", " ", "indicate", " ", "one", " ", 
      "solution", " ", "inside", " ", "unit"}], ",", " ", 
     RowBox[{"psi", " ", "is", " ", "inside", " ", "unit", " ", "circle"}]}], 
    "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]"}]}]], "Input",
 CellChangeTimes->{{3.819866266443254*^9, 3.8198662671274204`*^9}, {
  3.819866324833249*^9, 3.819866326776042*^9}},
 CellLabel->
  "In[139]:=",ExpressionUUID->"fc790c2e-c425-43a8-8600-37411f5dc5f3"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"ClearAll", "[", "\"\<`*\>\"", "]"}], ";"}], "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{"Compute", " ", 
    RowBox[{
     RowBox[{"b", "^", 
      RowBox[{"(", 
       RowBox[{"T", "*", 
        RowBox[{"-", "1"}]}], ")"}]}], "."}]}], "*)"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Bpost", "=", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"0", ",", "0", ",", 
        FractionBox[
         RowBox[{
          RowBox[{"-", 
           RowBox[{"(", 
            RowBox[{"1", "-", 
             RowBox[{"\[Beta]", " ", "psi"}]}], ")"}]}], "/", "\[Kappa]"}], 
         RowBox[{" ", "\[Alpha]", " "}]], ",", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"1", "-", 
           RowBox[{"\[Beta]", " ", "psi"}]}], ")"}], "/", "\[Kappa]"}]}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"0", ",", "0", ",", 
        RowBox[{"-", 
         FractionBox["1", "\[Alpha]"]}], ",", "1"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"0", ",", "0", ",", 
        FractionBox[
         RowBox[{"-", "psi"}], 
         RowBox[{" ", "\[Alpha]", " "}]], ",", "psi"}], "}"}]}], "}"}]}], 
   ";"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"A0z", " ", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"1", "+", 
        RowBox[{"\[Sigma]", " ", "\[Phi]ya"}]}], ",", 
       RowBox[{"\[Sigma]", " ", "\[Phi]a"}], ",", " ", "0", ",", "0"}], "}"}],
      ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "\[Kappa]"}], ",", "1", ",", "0", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", 
       RowBox[{"-", "1"}], ",", "1", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "0", ",", "1"}], "}"}]}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"A1z", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", 
       FractionBox["1", "\[Alpha]"], ",", 
       RowBox[{"-", "1"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}]}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"B0z", " ", "=", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"1", ",", "\[Sigma]", ",", "0", ",", "0"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"0", ",", "\[Beta]", ",", "0", ",", "0"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"0", ",", "1", ",", "0", ",", "0"}], "}"}]}], "}"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Abarz", " ", "=", " ", 
   RowBox[{
    RowBox[{"Inverse", "[", "A0z", "]"}], ".", "A1z"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Bbarz", "=", " ", 
    RowBox[{
     RowBox[{
      RowBox[{"Inverse", "[", "A0z", "]"}], ".", "B0z"}], " ", "//", 
     "Simplify"}]}], ";"}], "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"BTmin1", "=", 
   RowBox[{"Simplify", "[", 
    RowBox[{
     RowBox[{"Inverse", "[", 
      RowBox[{
       RowBox[{"IdentityMatrix", "[", "4", "]"}], "-", 
       RowBox[{"Bbarz", ".", "Bpost"}]}], "]"}], ".", "Abarz"}], "]"}]}], " ", 
  RowBox[{"(*", 
   RowBox[{"Compute", " ", 
    RowBox[{
     RowBox[{"b", "^", 
      RowBox[{"(", 
       RowBox[{"T", "*", 
        RowBox[{"-", "1"}]}], ")"}]}], "."}]}], "*)"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]"}], "Input",
 CellChangeTimes->{{3.816663530608317*^9, 3.816663555178439*^9}, {
  3.8166635987660007`*^9, 3.816663633899051*^9}, {3.816663979463035*^9, 
  3.816663983146202*^9}, {3.8166640548002863`*^9, 3.816664069569855*^9}, {
  3.8166641586727967`*^9, 3.816664225697734*^9}, {3.8166644982489834`*^9, 
  3.8166645005219035`*^9}, {3.8166661653416405`*^9, 3.816666171433367*^9}, {
  3.8166662825415974`*^9, 3.816666291882637*^9}, {3.816670494850464*^9, 
  3.8166704963295126`*^9}, {3.8195177897131214`*^9, 3.8195178056716027`*^9}, {
  3.819517838956111*^9, 3.8195178402117987`*^9}, {3.819862134612923*^9, 
  3.819862148277188*^9}, {3.8198621854303427`*^9, 3.8198621913081408`*^9}},
 CellLabel->
  "In[140]:=",ExpressionUUID->"d96e7f2b-86a7-4041-b347-476291790e8b"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"0", ",", "0", ",", 
     FractionBox[
      RowBox[{
       RowBox[{"-", "1"}], "+", 
       RowBox[{"psi", " ", "\[Beta]"}], "+", 
       RowBox[{"\[Kappa]", " ", "\[Sigma]", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "1"}], "+", 
          RowBox[{"\[Beta]", " ", "\[Phi]a"}]}], ")"}]}]}], 
      RowBox[{"\[Alpha]", " ", "\[Kappa]", " ", 
       RowBox[{"(", 
        RowBox[{"1", "+", "\[Beta]", "-", 
         RowBox[{"psi", " ", "\[Beta]"}], "+", 
         RowBox[{"\[Kappa]", " ", "\[Sigma]"}], "+", 
         RowBox[{"\[Beta]", " ", "\[Sigma]", " ", "\[Phi]ya"}]}], ")"}]}]], 
     ",", 
     FractionBox[
      RowBox[{"1", "-", 
       RowBox[{"psi", " ", "\[Beta]"}], "+", 
       RowBox[{"\[Kappa]", " ", 
        RowBox[{"(", 
         RowBox[{"\[Sigma]", "-", 
          RowBox[{"\[Beta]", " ", "\[Sigma]", " ", "\[Phi]a"}]}], ")"}]}]}], 
      RowBox[{"\[Kappa]", " ", 
       RowBox[{"(", 
        RowBox[{"1", "+", "\[Beta]", "-", 
         RowBox[{"psi", " ", "\[Beta]"}], "+", 
         RowBox[{"\[Kappa]", " ", "\[Sigma]"}], "+", 
         RowBox[{"\[Beta]", " ", "\[Sigma]", " ", "\[Phi]ya"}]}], ")"}]}]]}], 
    "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "0", ",", 
     RowBox[{"-", 
      FractionBox["1", "\[Alpha]"]}], ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "0", ",", 
     RowBox[{"-", 
      FractionBox[
       RowBox[{"1", "+", 
        RowBox[{"\[Kappa]", " ", "\[Sigma]", " ", "\[Phi]a"}], "+", 
        RowBox[{"\[Sigma]", " ", "\[Phi]ya"}]}], 
       RowBox[{"\[Alpha]", " ", 
        RowBox[{"(", 
         RowBox[{"1", "+", "\[Beta]", "-", 
          RowBox[{"psi", " ", "\[Beta]"}], "+", 
          RowBox[{"\[Kappa]", " ", "\[Sigma]"}], "+", 
          RowBox[{"\[Beta]", " ", "\[Sigma]", " ", "\[Phi]ya"}]}], ")"}]}]]}],
      ",", 
     FractionBox[
      RowBox[{"1", "+", 
       RowBox[{"\[Kappa]", " ", "\[Sigma]", " ", "\[Phi]a"}], "+", 
       RowBox[{"\[Sigma]", " ", "\[Phi]ya"}]}], 
      RowBox[{"1", "+", "\[Beta]", "-", 
       RowBox[{"psi", " ", "\[Beta]"}], "+", 
       RowBox[{"\[Kappa]", " ", "\[Sigma]"}], "+", 
       RowBox[{"\[Beta]", " ", "\[Sigma]", " ", "\[Phi]ya"}]}]]}], "}"}]}], 
  "}"}]], "Output",
 CellChangeTimes->{
  3.8166663011460648`*^9, 3.8166704975781803`*^9, {3.8195178151044793`*^9, 
   3.819517842584466*^9}, 3.8195180050131235`*^9, 3.8195200362433076`*^9, 
   3.819520338217999*^9, 3.8195257660478687`*^9, 3.819862154748416*^9, 
   3.8198622137159557`*^9, 3.8198679274046497`*^9},
 CellLabel->
  "Out[147]=",ExpressionUUID->"5b19c6fb-e665-4a7d-a1ca-42ba36054d26"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Simplify", "[", 
  RowBox[{
   FractionBox[
    RowBox[{"1", "-", 
     RowBox[{"psi", " ", "\[Beta]"}], "+", 
     RowBox[{"\[Kappa]", " ", 
      RowBox[{"(", 
       RowBox[{"\[Sigma]", "-", 
        RowBox[{"\[Beta]", " ", "\[Sigma]", " ", "\[Phi]a"}]}], ")"}]}]}], 
    RowBox[{"\[Kappa]", " ", 
     RowBox[{"(", 
      RowBox[{"1", "+", "\[Beta]", "-", 
       RowBox[{"psi", " ", "\[Beta]"}], "+", 
       RowBox[{"\[Kappa]", " ", "\[Sigma]"}], "+", 
       RowBox[{"\[Beta]", " ", "\[Sigma]", " ", "\[Phi]ya"}]}], ")"}]}]], "-", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"1", "-", 
      RowBox[{"\[Beta]", 
       FractionBox[
        RowBox[{"1", "+", 
         RowBox[{"\[Kappa]", " ", "\[Sigma]", " ", "\[Phi]a"}], "+", 
         RowBox[{"\[Sigma]", " ", "\[Phi]ya"}]}], 
        RowBox[{"1", "+", "\[Beta]", "-", 
         RowBox[{"psi", " ", "\[Beta]"}], "+", 
         RowBox[{"\[Kappa]", " ", "\[Sigma]"}], "+", 
         RowBox[{"\[Beta]", " ", "\[Sigma]", " ", "\[Phi]ya"}]}]]}]}], ")"}], 
    RowBox[{"(", 
     FractionBox["1", 
      RowBox[{"\[Kappa]", " "}]], ")"}]}]}], "]"}]], "Input",
 CellChangeTimes->{{3.8166689215389137`*^9, 3.816668923799864*^9}, {
  3.8166703988471546`*^9, 3.8166704277954473`*^9}, {3.8195178487397785`*^9, 
  3.8195178585841513`*^9}, {3.819517889682534*^9, 3.8195178997927527`*^9}, {
  3.81951802153225*^9, 3.8195180350719566`*^9}, {3.8195200518645954`*^9, 
  3.819520058748392*^9}, {3.8198622218616915`*^9, 3.819862230376998*^9}},
 CellLabel->
  "In[148]:=",ExpressionUUID->"54269259-7143-4ac7-bf25-8c20f74774a6"],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{
  3.8195178638152328`*^9, 3.819517901083325*^9, {3.8195180284136477`*^9, 
   3.8195180362807455`*^9}, {3.819520060260313*^9, 3.819520080110731*^9}, 
   3.819520344996891*^9, 3.819525767949741*^9, 3.8198622320934105`*^9, 
   3.8198679319715233`*^9},
 CellLabel->
  "Out[148]=",ExpressionUUID->"fbf2585e-f039-407b-973f-767e0aeef8f3"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{"Compute", " ", 
    RowBox[{
     RowBox[{"b", "^", 
      RowBox[{"(", 
       RowBox[{"T", "*", 
        RowBox[{"-", "2"}]}], ")"}]}], "."}]}], "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"BTmin1", "=", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", 
         FractionBox[
          RowBox[{
           RowBox[{"-", 
            RowBox[{"(", 
             RowBox[{"1", "-", 
              RowBox[{"\[Beta]", " ", "psi1"}]}], ")"}]}], "/", "\[Kappa]"}], 
          RowBox[{" ", "\[Alpha]", " "}]], ",", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"1", "-", 
            RowBox[{"\[Beta]", " ", "psi1"}]}], ")"}], "/", "\[Kappa]"}]}], 
        "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", 
         RowBox[{"-", 
          FractionBox["1", "\[Alpha]"]}], ",", "1"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", 
         FractionBox[
          RowBox[{"-", "psi1"}], 
          RowBox[{" ", "\[Alpha]", " "}]], ",", "psi1"}], "}"}]}], "}"}]}], 
    ";"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{"BTmin2", "=", 
    RowBox[{"Simplify", "[", 
     RowBox[{
      RowBox[{"Inverse", "[", 
       RowBox[{
        RowBox[{"IdentityMatrix", "[", "4", "]"}], "-", 
        RowBox[{"Bbarz", ".", "BTmin1"}]}], "]"}], ".", "Abarz"}], "]"}]}], 
   "\[IndentingNewLine]"}]}]], "Input",
 CellChangeTimes->{{3.8166704530929003`*^9, 3.816670482268545*^9}, {
  3.816670527245135*^9, 3.8166705663831625`*^9}, {3.819518471084715*^9, 
  3.8195184765072556`*^9}, {3.8195200956511717`*^9, 3.8195200999008536`*^9}, {
  3.8198621970338364`*^9, 3.81986219903251*^9}, {3.8198622872534204`*^9, 
  3.8198622877385287`*^9}, {3.8198623350779285`*^9, 3.8198623499042697`*^9}},
 CellLabel->
  "In[149]:=",ExpressionUUID->"4a12d9e1-f6be-4389-b08c-017617b23524"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"0", ",", "0", ",", 
     FractionBox[
      RowBox[{
       RowBox[{"-", "1"}], "+", 
       RowBox[{"psi1", " ", "\[Beta]"}], "+", 
       RowBox[{"\[Kappa]", " ", "\[Sigma]", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "1"}], "+", 
          RowBox[{"\[Beta]", " ", "\[Phi]a"}]}], ")"}]}]}], 
      RowBox[{"\[Alpha]", " ", "\[Kappa]", " ", 
       RowBox[{"(", 
        RowBox[{"1", "+", "\[Beta]", "-", 
         RowBox[{"psi1", " ", "\[Beta]"}], "+", 
         RowBox[{"\[Kappa]", " ", "\[Sigma]"}], "+", 
         RowBox[{"\[Beta]", " ", "\[Sigma]", " ", "\[Phi]ya"}]}], ")"}]}]], 
     ",", 
     FractionBox[
      RowBox[{"1", "-", 
       RowBox[{"psi1", " ", "\[Beta]"}], "+", 
       RowBox[{"\[Kappa]", " ", 
        RowBox[{"(", 
         RowBox[{"\[Sigma]", "-", 
          RowBox[{"\[Beta]", " ", "\[Sigma]", " ", "\[Phi]a"}]}], ")"}]}]}], 
      RowBox[{"\[Kappa]", " ", 
       RowBox[{"(", 
        RowBox[{"1", "+", "\[Beta]", "-", 
         RowBox[{"psi1", " ", "\[Beta]"}], "+", 
         RowBox[{"\[Kappa]", " ", "\[Sigma]"}], "+", 
         RowBox[{"\[Beta]", " ", "\[Sigma]", " ", "\[Phi]ya"}]}], ")"}]}]]}], 
    "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "0", ",", 
     RowBox[{"-", 
      FractionBox["1", "\[Alpha]"]}], ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "0", ",", 
     RowBox[{"-", 
      FractionBox[
       RowBox[{"1", "+", 
        RowBox[{"\[Kappa]", " ", "\[Sigma]", " ", "\[Phi]a"}], "+", 
        RowBox[{"\[Sigma]", " ", "\[Phi]ya"}]}], 
       RowBox[{"\[Alpha]", " ", 
        RowBox[{"(", 
         RowBox[{"1", "+", "\[Beta]", "-", 
          RowBox[{"psi1", " ", "\[Beta]"}], "+", 
          RowBox[{"\[Kappa]", " ", "\[Sigma]"}], "+", 
          RowBox[{"\[Beta]", " ", "\[Sigma]", " ", "\[Phi]ya"}]}], ")"}]}]]}],
      ",", 
     FractionBox[
      RowBox[{"1", "+", 
       RowBox[{"\[Kappa]", " ", "\[Sigma]", " ", "\[Phi]a"}], "+", 
       RowBox[{"\[Sigma]", " ", "\[Phi]ya"}]}], 
      RowBox[{"1", "+", "\[Beta]", "-", 
       RowBox[{"psi1", " ", "\[Beta]"}], "+", 
       RowBox[{"\[Kappa]", " ", "\[Sigma]"}], "+", 
       RowBox[{"\[Beta]", " ", "\[Sigma]", " ", "\[Phi]ya"}]}]]}], "}"}]}], 
  "}"}]], "Output",
 CellChangeTimes->{{3.8198622824606733`*^9, 3.819862288727227*^9}, {
   3.819862338507168*^9, 3.819862350620463*^9}, 3.8198679364590845`*^9},
 CellLabel->
  "Out[150]=",ExpressionUUID->"a0a66e5b-4b3f-4797-b191-0104512eefeb"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FullSimplify", "[", 
  RowBox[{
   FractionBox[
    RowBox[{"1", "-", 
     RowBox[{"psi1", " ", "\[Beta]"}], "+", 
     RowBox[{"\[Kappa]", " ", 
      RowBox[{"(", 
       RowBox[{"\[Sigma]", "-", 
        RowBox[{"\[Beta]", " ", "\[Sigma]", " ", "\[Phi]a"}]}], ")"}]}]}], 
    RowBox[{"\[Kappa]", " ", 
     RowBox[{"(", 
      RowBox[{"1", "+", "\[Beta]", "-", 
       RowBox[{"psi1", " ", "\[Beta]"}], "+", 
       RowBox[{"\[Kappa]", " ", "\[Sigma]"}], "+", 
       RowBox[{"\[Beta]", " ", "\[Sigma]", " ", "\[Phi]ya"}]}], ")"}]}]], "-", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"1", "-", 
      RowBox[{"\[Beta]", 
       FractionBox[
        RowBox[{"1", "+", 
         RowBox[{"\[Kappa]", " ", "\[Sigma]", " ", "\[Phi]a"}], "+", 
         RowBox[{"\[Sigma]", " ", "\[Phi]ya"}]}], 
        RowBox[{"1", "+", "\[Beta]", "-", 
         RowBox[{"psi1", " ", "\[Beta]"}], "+", 
         RowBox[{"\[Kappa]", " ", "\[Sigma]"}], "+", 
         RowBox[{"\[Beta]", " ", "\[Sigma]", " ", "\[Phi]ya"}]}]]}]}], ")"}], 
    "/", "\[Kappa]"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.8195425031429405`*^9, 3.8195425072549467`*^9}, {
  3.819862296064286*^9, 3.819862302016387*^9}},
 CellLabel->
  "In[151]:=",ExpressionUUID->"89275e4e-ea01-42a9-9038-4d491f9ffd73"],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{3.819542509189793*^9, 3.8198623045991864`*^9, 
  3.8198679412617674`*^9},
 CellLabel->
  "Out[151]=",ExpressionUUID->"87da1e0e-393a-4fc3-86c9-6e6fb271b9d8"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"(*", 
  RowBox[{
   RowBox[{
    RowBox[{"Proof", " ", "by", " ", "induction", " ", 
     RowBox[{"shows", ":", "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"b", 
       RowBox[{"(", "j", ")"}]}]}]}], "=", 
    RowBox[{
     RowBox[{
      TagBox[
       RowBox[{"(", "\[NoBreak]", GridBox[{
          {"0", "0", 
           FractionBox[
            RowBox[{
             RowBox[{"-", 
              RowBox[{"(", 
               RowBox[{"1", "-", 
                RowBox[{"\[Beta]", " ", "psi", 
                 RowBox[{"(", "j", ")"}]}]}], ")"}]}], "/", "\[Kappa]"}], 
            RowBox[{" ", "\[Alpha]", " "}]], 
           RowBox[{
            RowBox[{"(", 
             RowBox[{"1", "-", 
              RowBox[{"\[Beta]", " ", "psi", 
               RowBox[{"(", "j", ")"}]}]}], ")"}], "/", "\[Kappa]"}]},
          {"0", "0", 
           RowBox[{"-", 
            FractionBox["1", "\[Alpha]"]}], "1"},
          {"0", "0", "0", "0"},
          {"0", "0", 
           RowBox[{"-", 
            FractionBox[
             RowBox[{"psi", 
              RowBox[{"(", "j", ")"}]}], 
             RowBox[{"\[Alpha]", " "}]]}], 
           RowBox[{"psi", 
            RowBox[{"(", "j", ")"}]}]}
         },
         GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Baseline}}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.7]}, 
             Offset[0.27999999999999997`]}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}}], "\[NoBreak]", ")"}],
       Function[BoxForm`e$, 
        MatrixForm[BoxForm`e$]]], " ", "where", " ", "psi", 
      RowBox[{"(", "j", ")"}]}], "=", " ", 
     RowBox[{
      RowBox[{
       FractionBox[
        RowBox[{"1", "+", 
         RowBox[{"\[Kappa]", " ", "\[Sigma]", " ", "\[Phi]a"}], "+", 
         RowBox[{"\[Sigma]", " ", "\[Phi]ya"}]}], 
        RowBox[{"1", "+", "\[Beta]", "-", 
         RowBox[{"psi", 
          RowBox[{"(", 
           RowBox[{"j", "-", "1"}], ")"}], "\[Beta]"}], "+", 
         RowBox[{"\[Kappa]", " ", "\[Sigma]"}], "+", 
         RowBox[{"\[Beta]", " ", "\[Sigma]", " ", "\[Phi]ya"}]}]], " ", "j"}],
       "=", 
      RowBox[{
       RowBox[{
        RowBox[{"T", "^"}], "*", 
        RowBox[{"-", "t"}]}], "=", "0"}]}]}]}], ",", "1", ",", "2", ",", 
   "..."}], "\[IndentingNewLine]", "\[IndentingNewLine]", "*)"}]], "Input",
 CellChangeTimes->{{3.819862310716981*^9, 3.819862317253493*^9}, {
   3.819862352916286*^9, 3.8198624041029787`*^9}, {3.8198624385314674`*^9, 
   3.8198624989145155`*^9}, 3.8198631285443583`*^9, {3.819863354755542*^9, 
   3.8198633829645295`*^9}, {3.8198679590623817`*^9, 
   3.819867974112826*^9}},ExpressionUUID->"9db4187c-318e-4c5e-8f76-\
88b24b611053"],

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{"Therefore", ",", " ", 
    RowBox[{
     RowBox[{
      RowBox[{"b", 
       RowBox[{"(", "j", ")"}], " ", "converges", " ", "as", " ", 
       RowBox[{"j", "--"}]}], ">", 
      RowBox[{"\[Infinity]", "  ", "iff", " ", "psi", 
       RowBox[{"(", "j", ")"}]}]}], "=", 
     RowBox[{
      FractionBox[
       RowBox[{"1", "+", "\[Kappa]\[Sigma]\[Phi]a", "+", "\[Sigma]\[Phi]ya"}], 
       RowBox[{"1", "+", "\[Beta]", "-", 
        RowBox[{"psi", 
         RowBox[{"(", 
          RowBox[{"j", "-", "1"}], ")"}], "\[Beta]"}], "+", 
        "\[Kappa]\[Sigma]", "+", "\[Beta]\[Sigma]\[Phi]ya"}]], "=", 
      RowBox[{"h", 
       RowBox[{"(", 
        RowBox[{"psi", 
         RowBox[{"(", 
          RowBox[{"j", "-", "1"}], ")"}]}], ")"}], "converges", " ", "to", 
       " ", 
       RowBox[{"psi_a", "."}]}]}]}]}], "*)"}], "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
      "The", " ", "following", " ", "steps", " ", "argue", " ", "that"}], " ",
       "-", "1"}], "<", "psi_a", "<", 
     RowBox[{"1", " ", "exists", " ", "and", " ", "h", 
      RowBox[{"(", 
       RowBox[{"psi", 
        RowBox[{"(", 
         RowBox[{"j", "-", "1"}], ")"}]}], ")"}], " ", "converges", " ", "to",
       " ", "psi_a"}]}], "=", 
    RowBox[{"h", 
     RowBox[{
      RowBox[{"(", "psi_a", ")"}], "."}]}]}], " ", "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"Step", " ", "1"}], ":", " ", 
      RowBox[{
       RowBox[{"Note", " ", "that", " ", 
        RowBox[{"h", "'"}], 
        RowBox[{"(", "psi", ")"}]}], ">", 
       RowBox[{"0", " ", "for", " ", "psi"}], "<", "psi_u"}]}], "=", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{
        "1", "+", "\[Beta]", "+", "\[Kappa]\[Sigma]", "+", 
         "\[Beta]\[Sigma]\[Phi]ya"}], ")"}], "/", "\[Beta]"}], ">", 
      RowBox[{"1.", " ", "Thus"}]}]}], ",", " ", 
    RowBox[{
     RowBox[{
      RowBox[{"h", 
       RowBox[{"(", "psi", ")"}], " ", "is", " ", "increasing", " ", "for", 
       " ", "all", " ", "psi"}], "<", 
      RowBox[{
       RowBox[{
       "psi_u", ".", "\[IndentingNewLine]", "\[IndentingNewLine]", "Step"}], 
       " ", "2"}]}], ":", " ", 
     RowBox[{
      RowBox[{"h", 
       RowBox[{
        RowBox[{"(", "psi", ")"}], "--"}]}], ">", " ", 
      RowBox[{"0", " ", "as", " ", 
       RowBox[{"psi", "--"}]}], ">", " ", 
      RowBox[{
       RowBox[{"-", 
        RowBox[{"\[Infinity]", ".", " ", "Step"}]}], " ", "1", " ", "and", 
       " ", "2", " ", "therefore", " ", "imply"}]}]}], ",", " ", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"h", 
        RowBox[{"(", "psi", ")"}]}], ">", 
       RowBox[{"psi", " ", "for", " ", "all", " ", "psi"}], "<", 
       RowBox[{"0", "\[IndentingNewLine]", "Step", " ", "3"}]}], ":", " ", 
      RowBox[{"h", 
       RowBox[{"(", "1", ")"}]}]}], "=", " ", 
     RowBox[{
      RowBox[{
       RowBox[{
        FractionBox[
         RowBox[{
         "1", "+", "\[Kappa]\[Sigma]\[Phi]a", "+", "\[Sigma]\[Phi]ya"}], 
         RowBox[{
         "1", "+", "\[Kappa]\[Sigma]", "+", "\[Beta]\[Sigma]\[Phi]ya"}]], "<", 
        RowBox[{"1", " ", "iff", " ", "\[Phi]a"}], "<", 
        RowBox[{"1", "+", 
         RowBox[{
          RowBox[{
           FractionBox[
            RowBox[{
             RowBox[{"(", 
              RowBox[{"\[Beta]", "-", "1"}], ")"}], "\[Phi]ya"}], "\[Kappa]"],
            ".", "\[IndentingNewLine]", " ", "Step"}], " ", "4"}]}]}], ":", 
       " ", 
       RowBox[{
        RowBox[{"h", 
         RowBox[{"(", "psi", ")"}]}], ">", 
        RowBox[{"psi", " ", "as", " ", 
         RowBox[{"psi", "--"}]}], ">", 
        RowBox[{
         RowBox[{
          RowBox[{
          "psi_u", ".", " ", "\[IndentingNewLine]", "\[IndentingNewLine]", 
           "Steps"}], " ", "2"}], "-", 
         RowBox[{
         "4", " ", "imply", " ", "there", " ", "exists", " ", "psi_A"}]}]}]}],
       "=", 
      RowBox[{
       RowBox[{"h", 
        RowBox[{"(", "psi_A", ")"}], " ", "and", " ", "psi_H"}], "=", 
       RowBox[{
        RowBox[{"h", 
         RowBox[{"(", "psi_H", ")"}], " ", "such", " ", "that", " ", 
         "psi_A"}], "<", "1", "<", 
        RowBox[{
         RowBox[{"psi_H", ".", " ", "and"}], " ", 
         RowBox[{"h", "'"}], 
         RowBox[{"(", "psi_a", ")"}]}], "<", "1", "<", 
        RowBox[{
         RowBox[{"h", "'"}], 
         RowBox[{
          RowBox[{"(", "psi_H", ")"}], ".", "\[IndentingNewLine]", 
          "\[IndentingNewLine]", "Therefore"}]}]}]}]}]}], ",", " ", 
    RowBox[{
     RowBox[{"psi_j", "--"}], ">", 
     RowBox[{"psi_A", " ", "as", " ", 
      RowBox[{"j", "--"}]}], ">", " ", 
     RowBox[{"\[Infinity]", "."}]}]}], " ", "*)"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]", "\[IndentingNewLine]"}]], "Input",
 CellChangeTimes->CompressedData["
1:eJwlx08oQwEAx/FnLKWYg1phtKRniPwpKRvLIodNkT+NWCsHor0dMCyxWpJZ
ONC0NH9SzA4ebQdOUh4m2w5Lu6ihFS+URUi833P49ukr1Rta+gQEQUi44FeG
yOE1sEqHrXcNdg3QG3CSXt+ExpGyY1hGvZ/B2XDiNWyLxgOw/0PyBANizQt0
rbpTfZzOBGE6ZJhRKWxYMpZCj5eohEbrIe9h8GYaLpsF8/C+I3YCoxYXA30m
qp4cZpW3i1YVzJ4paoKWd7savi1kPcKQPScOVxxsWgFerhLBTJkwX8ZZ4mwm
oc5MnBdyplTmXkLXXXIIXkSof8WKKLzaVfN6I1csPBIqXqHokyQrOA+qinkH
q58V1/ianTpIhX86YI+msRN2j2nmIM3M26COtm7CoX3pNrR5lt3Q9KH1w1E9
lRzgDD9oJdDeysqh/7S9FvarvofgVixvHJYnTfwGOfeepnj/AA3x9kM=
  "],ExpressionUUID->"bd491e56-c14b-4891-acea-dffefbd60a2d"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"ClearAll", "[", "\"\<`*\>\"", "]"}], ";", " ", 
  RowBox[{"(*", 
   RowBox[{"Solve", " ", "for", " ", "psi_A", " ", "and", " ", "psi_H"}], 
   "*)"}], "\[IndentingNewLine]", 
  RowBox[{"Solve", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      FractionBox[
       RowBox[{"1", "+", 
        RowBox[{"\[Kappa]", " ", "\[Sigma]", " ", "\[Phi]a"}], "+", 
        RowBox[{"\[Sigma]", " ", "\[Phi]ya"}]}], 
       RowBox[{"1", "+", "\[Beta]", "-", 
        RowBox[{"x", " ", "\[Beta]"}], "+", 
        RowBox[{"\[Kappa]", " ", "\[Sigma]"}], "+", 
        RowBox[{"\[Beta]", " ", "\[Sigma]", " ", "\[Phi]ya"}]}]], "-", "x"}], 
     "\[Equal]", "0"}], ",", "x"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.8166672694981675`*^9, 3.81666727172395*^9}, {
   3.8166674245626087`*^9, 3.816667426201228*^9}, {3.8195185898698206`*^9, 
   3.819518606790575*^9}, 3.8195186710618324`*^9, {3.819518829986299*^9, 
   3.819518830419144*^9}, 3.8195201277854033`*^9, {3.8195203621991105`*^9, 
   3.819520364505948*^9}, {3.8198652811315904`*^9, 
   3.8198652876758227`*^9}},ExpressionUUID->"e91a86a8-6f70-4747-b450-\
1dee65695723"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"x", "\[Rule]", 
     FractionBox[
      RowBox[{"1", "+", "\[Beta]", "+", 
       RowBox[{"\[Kappa]", " ", "\[Sigma]"}], "+", 
       RowBox[{"\[Beta]", " ", "\[Sigma]", " ", "\[Phi]ya"}], "-", 
       SqrtBox[
        RowBox[{
         RowBox[{"4", " ", "\[Beta]", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "1"}], "-", 
            RowBox[{"\[Kappa]", " ", "\[Sigma]", " ", "\[Phi]a"}], "-", 
            RowBox[{"\[Sigma]", " ", "\[Phi]ya"}]}], ")"}]}], "+", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"1", "+", "\[Beta]", "+", 
            RowBox[{"\[Kappa]", " ", "\[Sigma]"}], "+", 
            RowBox[{"\[Beta]", " ", "\[Sigma]", " ", "\[Phi]ya"}]}], ")"}], 
          "2"]}]]}], 
      RowBox[{"2", " ", "\[Beta]"}]]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"x", "\[Rule]", 
     FractionBox[
      RowBox[{"1", "+", "\[Beta]", "+", 
       RowBox[{"\[Kappa]", " ", "\[Sigma]"}], "+", 
       RowBox[{"\[Beta]", " ", "\[Sigma]", " ", "\[Phi]ya"}], "+", 
       SqrtBox[
        RowBox[{
         RowBox[{"4", " ", "\[Beta]", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "1"}], "-", 
            RowBox[{"\[Kappa]", " ", "\[Sigma]", " ", "\[Phi]a"}], "-", 
            RowBox[{"\[Sigma]", " ", "\[Phi]ya"}]}], ")"}]}], "+", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"1", "+", "\[Beta]", "+", 
            RowBox[{"\[Kappa]", " ", "\[Sigma]"}], "+", 
            RowBox[{"\[Beta]", " ", "\[Sigma]", " ", "\[Phi]ya"}]}], ")"}], 
          "2"]}]]}], 
      RowBox[{"2", " ", "\[Beta]"}]]}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{
  3.816667698455864*^9, {3.8195185978585043`*^9, 3.819518610301603*^9}, 
   3.819518673368374*^9, 3.819519969277485*^9, 3.8195201294170446`*^9, 
   3.819520365752618*^9, 3.819525783905053*^9, 3.8195426900022144`*^9, 
   3.819543867784809*^9},
 CellLabel->
  "Out[1004]=",ExpressionUUID->"b6bb4e84-9958-41bb-a395-7cf162c06e59"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"(*", 
  RowBox[{
  "Manually", " ", "Simplify", " ", "term", " ", "in", " ", "square", " ", 
   RowBox[{"root", ":"}]}], "*)"}]], "Input",
 CellChangeTimes->{{3.819520431043318*^9, 3.8195204504524355`*^9}, {
  3.8195256764105377`*^9, 
  3.8195256819686837`*^9}},ExpressionUUID->"f5b756fe-fbaa-4368-b2cf-\
0efcc04434ef"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Simplify", "[", 
  RowBox[{
   FractionBox[
    RowBox[{"1", "+", "\[Beta]", "+", 
     RowBox[{"\[Kappa]", " ", "\[Sigma]"}], "+", 
     RowBox[{"\[Beta]", " ", "\[Sigma]", " ", "\[Phi]ya"}], "-", 
     SqrtBox[
      RowBox[{
       RowBox[{"4", " ", "\[Beta]", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "1"}], "-", 
          RowBox[{"\[Kappa]", " ", "\[Sigma]", " ", "\[Phi]a"}], "-", 
          RowBox[{"\[Sigma]", " ", "\[Phi]ya"}]}], ")"}]}], "+", 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"1", "+", "\[Beta]", "+", 
          RowBox[{"\[Kappa]", " ", "\[Sigma]"}], "+", 
          RowBox[{"\[Beta]", " ", "\[Sigma]", " ", "\[Phi]ya"}]}], ")"}], 
        "2"]}]]}], 
    RowBox[{"2", " ", "\[Beta]"}]], "-", 
   FractionBox[
    RowBox[{"1", "+", "\[Beta]", "+", 
     RowBox[{"\[Kappa]", " ", "\[Sigma]"}], "+", 
     RowBox[{"\[Beta]", " ", "\[Sigma]", " ", "\[Phi]ya"}], "-", 
     SqrtBox[
      RowBox[{
       RowBox[{
        RowBox[{"-", "4"}], " ", "\[Kappa]", " ", "\[Sigma]", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "1"}], "+", 
          RowBox[{"\[Beta]", " ", "\[Phi]a"}]}], ")"}]}], "+", 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "1"}], "+", "\[Beta]", "+", 
          RowBox[{"\[Kappa]", " ", "\[Sigma]"}], "+", 
          RowBox[{"\[Beta]", " ", "\[Sigma]", " ", "\[Phi]ya"}]}], ")"}], 
        "2"]}]]}], 
    RowBox[{"2", " ", "\[Beta]"}]]}], "]"}]], "Input",
 CellLabel->
  "In[709]:=",ExpressionUUID->"65ee3a95-5a40-48db-b60b-1d7d0a861446"],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{3.8195204542562623`*^9, 3.8195257883451166`*^9},
 CellLabel->
  "Out[709]=",ExpressionUUID->"0a84877e-4259-4f2c-8f58-28f430ebce5a"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"(*", 
  RowBox[{
   RowBox[{
    RowBox[{"Notice", " ", "that", " ", "\[Phi]a"}], "<", 
    RowBox[{
     RowBox[{
     "1", " ", "implies", " ", "square", " ", "root", " ", "expression", " ", 
      "is", " ", "real"}], "-", 
     RowBox[{
      RowBox[{"valued", ".", " ", "Also"}], " ", "notice", " ", "that", " ", 
      "psiH", " ", "is", " ", "clearly", " ", "larger", " ", "than", " ", 
      RowBox[{"one", ".", " ", "Though"}], " ", "we", " ", "just", " ", 
      "proved", " ", "psiA"}]}], "<", "1", "<", "psiH"}], ",", " ", 
   RowBox[{
    RowBox[{
     RowBox[{"the", " ", "argument", " ", "for"}], " ", "-", "1"}], "<", 
    "psi", "<", 
    RowBox[{
     RowBox[{
     "1", " ", "also", " ", "can", " ", "be", " ", "slightly", " ", 
      "modified", " ", "to", " ", "prove"}], " ", "-", "1"}], "<", "psiA", 
    "<", "1."}]}], "*)"}]], "Input",
 CellChangeTimes->{{3.819520857119355*^9, 3.8195208831895647`*^9}, {
   3.8195249938028345`*^9, 3.819525007632186*^9}, {3.8198653536946297`*^9, 
   3.8198653576915383`*^9}, 3.8198655110376015`*^9, {3.8198664114745436`*^9, 
   3.8198664468283477`*^9}},ExpressionUUID->"8339c3ba-7f97-414d-abf5-\
5bc3b2e91517"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"psiA", "=", 
   FractionBox[
    RowBox[{"1", "+", "\[Beta]", "+", 
     RowBox[{"\[Kappa]", " ", "\[Sigma]"}], "+", 
     RowBox[{"\[Beta]", " ", "\[Sigma]", " ", "\[Phi]ya"}], "-", 
     SqrtBox[
      RowBox[{
       RowBox[{"4", " ", "\[Kappa]", " ", "\[Sigma]", " ", 
        RowBox[{"(", 
         RowBox[{"1", "-", 
          RowBox[{"\[Beta]", " ", "\[Phi]a"}]}], ")"}]}], "+", 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "1"}], "+", "\[Beta]", "+", 
          RowBox[{"\[Kappa]", " ", "\[Sigma]"}], "+", 
          RowBox[{"\[Beta]", " ", "\[Sigma]", " ", "\[Phi]ya"}]}], ")"}], 
        "2"]}]]}], 
    RowBox[{"2", " ", "\[Beta]"}]]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"psiH", "=", 
   FractionBox[
    RowBox[{"1", "+", "\[Beta]", "+", 
     RowBox[{"\[Kappa]", " ", "\[Sigma]"}], "+", 
     RowBox[{"\[Beta]", " ", "\[Sigma]", " ", "\[Phi]ya"}], "+", 
     SqrtBox[
      RowBox[{
       RowBox[{"4", " ", "\[Kappa]", " ", "\[Sigma]", " ", 
        RowBox[{"(", 
         RowBox[{"1", "-", 
          RowBox[{"\[Beta]", " ", "\[Phi]a"}]}], ")"}]}], "+", 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "1"}], "+", "\[Beta]", "+", 
          RowBox[{"\[Kappa]", " ", "\[Sigma]"}], "+", 
          RowBox[{"\[Beta]", " ", "\[Sigma]", " ", "\[Phi]ya"}]}], ")"}], 
        "2"]}]]}], 
    RowBox[{"2", " ", "\[Beta]"}]]}], ";"}]}], "Input",
 CellChangeTimes->{{3.8195204610162725`*^9, 3.8195204706525884`*^9}, {
  3.819522461016906*^9, 3.819522470700057*^9}, {3.8195225685422544`*^9, 
  3.8195225691655693`*^9}, {3.8198655003814726`*^9, 
  3.819865506334173*^9}},ExpressionUUID->"b0b44f54-58fa-4c7f-8e84-\
2105bb9ea39e"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"ClearAll", "[", "\"\<`*\>\"", "]"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"psiA", "=", 
     FractionBox[
      RowBox[{"1", "+", "\[Beta]", "+", 
       RowBox[{"\[Kappa]", " ", "\[Sigma]"}], "+", 
       RowBox[{"\[Beta]", " ", "\[Sigma]", " ", "\[Phi]ya"}], "-", 
       SqrtBox[
        RowBox[{
         RowBox[{"4", " ", "\[Kappa]", " ", "\[Sigma]", " ", 
          RowBox[{"(", 
           RowBox[{"1", "-", 
            RowBox[{"\[Beta]", " ", "\[Phi]a"}]}], ")"}]}], "+", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "1"}], "+", "\[Beta]", "+", 
            RowBox[{"\[Kappa]", " ", "\[Sigma]"}], "+", 
            RowBox[{"\[Beta]", " ", "\[Sigma]", " ", "\[Phi]ya"}]}], ")"}], 
          "2"]}]]}], 
      RowBox[{"2", " ", "\[Beta]"}]]}], ";"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"A0z", " ", "=", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"1", "+", 
          RowBox[{"\[Sigma]", " ", "\[Phi]ya"}]}], ",", 
         RowBox[{"\[Sigma]", " ", "\[Phi]a"}], ",", " ", "0", ",", "0"}], 
        "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "\[Kappa]"}], ",", "1", ",", "0", ",", "0"}], "}"}], 
       ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", 
         RowBox[{"-", "1"}], ",", "1", ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", "0", ",", "1"}], "}"}]}], "}"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"A1z", "=", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", 
         FractionBox["1", "\[Alpha]"], ",", 
         RowBox[{"-", "1"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}]}], "}"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"B0z", " ", "=", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"1", ",", "\[Sigma]", ",", "0", ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "\[Beta]", ",", "0", ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "1", ",", "0", ",", "0"}], "}"}]}], "}"}]}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
     RowBox[{"D0", " ", "=", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", "0", "}"}], ",", 
        RowBox[{"{", "0", "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"-", "1"}], "}"}], ",", 
        RowBox[{"{", "0", "}"}]}], "}"}]}], ";"}], "*)"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Abarz", " ", "=", " ", 
     RowBox[{
      RowBox[{"Inverse", "[", "A0z", "]"}], ".", "A1z"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Bbarz", "=", " ", 
     RowBox[{
      RowBox[{
       RowBox[{"Inverse", "[", "A0z", "]"}], ".", "B0z"}], " ", "//", 
      "Simplify"}]}], ";"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Solutionsz", "=", 
     RowBox[{
      RowBox[{"Solve", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"b11", ",", "b12", ",", "b13", ",", "b14"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"b21", ",", "b22", ",", "b23", ",", "b24"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"b31", ",", "b32", ",", "b33", ",", "b34"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"b41", ",", "b42", ",", "b43", ",", "b44"}], "}"}]}], 
          "}"}], "\[Equal]", 
         RowBox[{
          RowBox[{"Inverse", "[", 
           RowBox[{
            RowBox[{"IdentityMatrix", "[", "4", "]"}], "-", 
            RowBox[{"Bbarz", ".", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{"b11", ",", "b12", ",", "b13", ",", "b14"}], "}"}], 
               ",", 
               RowBox[{"{", 
                RowBox[{"b21", ",", "b22", ",", "b23", ",", "b24"}], "}"}], 
               ",", 
               RowBox[{"{", 
                RowBox[{"b31", ",", "b32", ",", "b33", ",", "b34"}], "}"}], 
               ",", 
               RowBox[{"{", 
                RowBox[{"b41", ",", "b42", ",", "b43", ",", "b44"}], "}"}]}], 
              "}"}]}]}], "]"}], ".", "Abarz"}]}], ",", 
        RowBox[{"{", 
         RowBox[{
         "b11", ",", "b12", ",", "b13", ",", "b14", ",", "b21", ",", "b22", 
          ",", "b23", ",", "b24", ",", "b31", ",", "b32", ",", "b33", ",", 
          "b34", ",", "b41", ",", "b42", ",", "b43", ",", "b44"}], "}"}]}], 
       "]"}], "//", "Simplify"}]}], ";"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"BFG", "=", 
     RowBox[{"FullSimplify", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"b11", ",", "b12", ",", "b13", ",", "b14"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"b21", ",", "b22", ",", "b23", ",", "b24"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"b31", ",", "b32", ",", "b33", ",", "b34"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"b41", ",", "b42", ",", "b43", ",", "b44"}], "}"}]}], 
         "}"}], "/.", 
        RowBox[{"Solutionsz", "[", 
         RowBox[{"[", "2", "]"}], "]"}]}], ",", 
       RowBox[{
        RowBox[{"\[Alpha]", ">", "0"}], "&&", 
        RowBox[{"\[Beta]", ">", "0"}], "&&", 
        RowBox[{"\[Sigma]", ">", "0"}], "&&", " ", 
        RowBox[{"\[Kappa]", ">", "0"}]}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"MatrixForm", "[", "BFG", "]"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]"}]}]], "Input",
 CellChangeTimes->{{3.8166670416802645`*^9, 3.8166671017006054`*^9}, {
  3.8166672843477187`*^9, 3.8166672850887403`*^9}, {3.8166676604202433`*^9, 
  3.8166676606147237`*^9}, {3.8195260617977314`*^9, 3.819526066239827*^9}, {
  3.8195261147135057`*^9, 3.819526122789467*^9}, {3.819866474611641*^9, 
  3.8198664968369694`*^9}, {3.819867668671489*^9, 3.819867678885281*^9}, {
  3.81986836032747*^9, 3.8198683608081846`*^9}},
 CellLabel->
  "In[152]:=",ExpressionUUID->"0f100a14-8db5-4522-848e-1f9d000add04"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0", "0", 
      FractionBox[
       RowBox[{
        RowBox[{"-", "1"}], "+", "\[Beta]", "+", 
        RowBox[{"\[Kappa]", " ", "\[Sigma]"}], "+", 
        RowBox[{"\[Beta]", " ", "\[Sigma]", " ", "\[Phi]ya"}], "-", 
        SqrtBox[
         RowBox[{
          RowBox[{
           RowBox[{"-", "4"}], " ", "\[Kappa]", " ", "\[Sigma]", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "1"}], "+", 
             RowBox[{"\[Beta]", " ", "\[Phi]a"}]}], ")"}]}], "+", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "1"}], "+", "\[Beta]", "+", 
             RowBox[{"\[Kappa]", " ", "\[Sigma]"}], "+", 
             RowBox[{"\[Beta]", " ", "\[Sigma]", " ", "\[Phi]ya"}]}], ")"}], 
           "2"]}]]}], 
       RowBox[{"2", " ", "\[Alpha]", " ", "\[Kappa]"}]], 
      RowBox[{"-", 
       FractionBox[
        RowBox[{
         RowBox[{"-", "1"}], "+", "\[Beta]", "+", 
         RowBox[{"\[Kappa]", " ", "\[Sigma]"}], "+", 
         RowBox[{"\[Beta]", " ", "\[Sigma]", " ", "\[Phi]ya"}], "-", 
         SqrtBox[
          RowBox[{
           RowBox[{
            RowBox[{"-", "4"}], " ", "\[Kappa]", " ", "\[Sigma]", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "1"}], "+", 
              RowBox[{"\[Beta]", " ", "\[Phi]a"}]}], ")"}]}], "+", 
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "1"}], "+", "\[Beta]", "+", 
              RowBox[{"\[Kappa]", " ", "\[Sigma]"}], "+", 
              RowBox[{"\[Beta]", " ", "\[Sigma]", " ", "\[Phi]ya"}]}], ")"}], 
            "2"]}]]}], 
        RowBox[{"2", " ", "\[Kappa]"}]]}]},
     {"0", "0", 
      RowBox[{"-", 
       FractionBox["1", "\[Alpha]"]}], "1"},
     {"0", "0", "0", "0"},
     {"0", "0", 
      RowBox[{"-", 
       FractionBox[
        RowBox[{"1", "+", "\[Beta]", "+", 
         RowBox[{"\[Kappa]", " ", "\[Sigma]"}], "+", 
         RowBox[{"\[Beta]", " ", "\[Sigma]", " ", "\[Phi]ya"}], "-", 
         SqrtBox[
          RowBox[{
           RowBox[{
            RowBox[{"-", "4"}], " ", "\[Kappa]", " ", "\[Sigma]", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "1"}], "+", 
              RowBox[{"\[Beta]", " ", "\[Phi]a"}]}], ")"}]}], "+", 
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "1"}], "+", "\[Beta]", "+", 
              RowBox[{"\[Kappa]", " ", "\[Sigma]"}], "+", 
              RowBox[{"\[Beta]", " ", "\[Sigma]", " ", "\[Phi]ya"}]}], ")"}], 
            "2"]}]]}], 
        RowBox[{"2", " ", "\[Alpha]", " ", "\[Beta]"}]]}], 
      FractionBox[
       RowBox[{"1", "+", "\[Beta]", "+", 
        RowBox[{"\[Kappa]", " ", "\[Sigma]"}], "+", 
        RowBox[{"\[Beta]", " ", "\[Sigma]", " ", "\[Phi]ya"}], "-", 
        SqrtBox[
         RowBox[{
          RowBox[{
           RowBox[{"-", "4"}], " ", "\[Kappa]", " ", "\[Sigma]", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "1"}], "+", 
             RowBox[{"\[Beta]", " ", "\[Phi]a"}]}], ")"}]}], "+", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "1"}], "+", "\[Beta]", "+", 
             RowBox[{"\[Kappa]", " ", "\[Sigma]"}], "+", 
             RowBox[{"\[Beta]", " ", "\[Sigma]", " ", "\[Phi]ya"}]}], ")"}], 
           "2"]}]]}], 
       RowBox[{"2", " ", "\[Beta]"}]]}
    },
    GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Baseline}}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.816667106271406*^9, 3.8166676711801205`*^9, 
  3.819526073953213*^9, 3.819526127841967*^9, 3.819866509637252*^9, 
  3.8198676816369886`*^9, 3.8198683737755947`*^9},
 CellLabel->
  "Out[161]//MatrixForm=",ExpressionUUID->"7b420dc3-ae0a-4624-b913-\
d0abe803f5a8"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Check1", "=", 
  RowBox[{"Simplify", "[", 
   RowBox[{
    FractionBox[
     RowBox[{"1", "+", "\[Beta]", "+", 
      RowBox[{"\[Kappa]", " ", "\[Sigma]"}], "+", 
      RowBox[{"\[Beta]", " ", "\[Sigma]", " ", "\[Phi]ya"}], "-", 
      SqrtBox[
       RowBox[{
        RowBox[{
         RowBox[{"-", "4"}], " ", "\[Kappa]", " ", "\[Sigma]", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "1"}], "+", 
           RowBox[{"\[Beta]", " ", "\[Phi]a"}]}], ")"}]}], "+", 
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "1"}], "+", "\[Beta]", "+", 
           RowBox[{"\[Kappa]", " ", "\[Sigma]"}], "+", 
           RowBox[{"\[Beta]", " ", "\[Sigma]", " ", "\[Phi]ya"}]}], ")"}], 
         "2"]}]]}], 
     RowBox[{"2", " ", "\[Beta]"}]], "-", "psiA"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.8166672917733803`*^9, 3.816667317102058*^9}, 
   3.816667690323968*^9, 3.8195260862803288`*^9, {3.8198665204778495`*^9, 
   3.8198665307898903`*^9}, 3.8198683789114933`*^9},
 CellLabel->
  "In[162]:=",ExpressionUUID->"3572788c-490e-4b85-af93-4b80c872a209"],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{
  3.8166673271791215`*^9, {3.816667691985523*^9, 3.8166677067414436`*^9}, 
   3.819526087606247*^9, 3.8195261308469095`*^9, {3.81986652615574*^9, 
   3.819866531369847*^9}, 3.819868380461858*^9},
 CellLabel->
  "Out[162]=",ExpressionUUID->"de64da7b-5a5e-4a4f-8fd6-60fb5067870a"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{"IE", "-", "STABILITY"}], "*)"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{"FIRST", " ", "CONDITION"}], "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"F", "=", 
    RowBox[{"MatrixForm", "[", 
     RowBox[{"Simplify", "[", 
      RowBox[{
       RowBox[{"Inverse", "[", 
        RowBox[{
         RowBox[{"IdentityMatrix", "[", "4", "]"}], "-", 
         RowBox[{"Bbarz", ".", "BFG"}]}], "]"}], ".", "Bbarz"}], "]"}], 
     "]"}]}], "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
     RowBox[{
      RowBox[{"/.", 
       RowBox[{"Solutions", "[", 
        RowBox[{"[", "1", "]"}], "]"}]}], "/.", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"\[Phi]", "\[Rule]", "1.5"}], ",", 
        RowBox[{"s", "\[Rule]", ".96"}], ",", 
        RowBox[{"\[Beta]", "\[Rule]", ".99"}], ",", 
        RowBox[{"\[Kappa]", "\[Rule]", ".02"}], ",", 
        RowBox[{"\[Sigma]", "\[Rule]", "0.5"}], ",", 
        RowBox[{"\[Lambda]", "\[Rule]", ".21"}], ",", 
        RowBox[{"\[Chi]", "\[Rule]", "1.48"}], ",", 
        RowBox[{"\[Alpha]", "\[Rule]", "1.5"}]}], "}"}]}], "//", 
     "Eigenvalues"}], "*)"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]"}]}]], "Input",
 CellChangeTimes->{{3.8166673319548717`*^9, 3.816667333478798*^9}, 
   3.8166676489698796`*^9, {3.8166677149888887`*^9, 3.8166677797187657`*^9}, {
   3.816668356143364*^9, 3.816668387441622*^9}, {3.8166684384891543`*^9, 
   3.8166684949546585`*^9}},
 CellLabel->
  "In[163]:=",ExpressionUUID->"8f561131-f7c2-4d68-95b5-8dabd7e6b9fd"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      FractionBox[
       RowBox[{"2", " ", "\[Beta]"}], 
       RowBox[{"1", "+", "\[Beta]", "+", 
        RowBox[{"\[Kappa]", " ", "\[Sigma]"}], "+", 
        RowBox[{"\[Beta]", " ", "\[Sigma]", " ", "\[Phi]ya"}], "+", 
        SqrtBox[
         RowBox[{
          RowBox[{
           RowBox[{"-", "4"}], " ", "\[Kappa]", " ", "\[Sigma]", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "1"}], "+", 
             RowBox[{"\[Beta]", " ", "\[Phi]a"}]}], ")"}]}], "+", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "1"}], "+", "\[Beta]", "+", 
             RowBox[{"\[Kappa]", " ", "\[Sigma]"}], "+", 
             RowBox[{"\[Beta]", " ", "\[Sigma]", " ", "\[Phi]ya"}]}], ")"}], 
           "2"]}]]}]], 
      FractionBox[
       RowBox[{"\[Alpha]", "-", "\[Beta]", "-", 
        RowBox[{"\[Alpha]", " ", "\[Beta]"}], "+", 
        SuperscriptBox["\[Beta]", "2"], "+", 
        RowBox[{"\[Alpha]", " ", "\[Kappa]", " ", "\[Sigma]"}], "+", 
        RowBox[{"\[Beta]", " ", "\[Kappa]", " ", "\[Sigma]"}], "-", 
        RowBox[{
        "2", " ", "\[Alpha]", " ", "\[Beta]", " ", "\[Kappa]", " ", 
         "\[Sigma]", " ", "\[Phi]a"}], "-", 
        RowBox[{
        "\[Alpha]", " ", "\[Beta]", " ", "\[Sigma]", " ", "\[Phi]ya"}], "+", 
        RowBox[{
         SuperscriptBox["\[Beta]", "2"], " ", "\[Sigma]", " ", "\[Phi]ya"}], 
        "+", 
        RowBox[{"\[Alpha]", " ", 
         SqrtBox[
          RowBox[{
           RowBox[{
            RowBox[{"-", "4"}], " ", "\[Kappa]", " ", "\[Sigma]", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "1"}], "+", 
              RowBox[{"\[Beta]", " ", "\[Phi]a"}]}], ")"}]}], "+", 
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "1"}], "+", "\[Beta]", "+", 
              RowBox[{"\[Kappa]", " ", "\[Sigma]"}], "+", 
              RowBox[{"\[Beta]", " ", "\[Sigma]", " ", "\[Phi]ya"}]}], ")"}], 
            "2"]}]]}], "-", 
        RowBox[{"\[Beta]", " ", 
         SqrtBox[
          RowBox[{
           RowBox[{
            RowBox[{"-", "4"}], " ", "\[Kappa]", " ", "\[Sigma]", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "1"}], "+", 
              RowBox[{"\[Beta]", " ", "\[Phi]a"}]}], ")"}]}], "+", 
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "1"}], "+", "\[Beta]", "+", 
              RowBox[{"\[Kappa]", " ", "\[Sigma]"}], "+", 
              RowBox[{"\[Beta]", " ", "\[Sigma]", " ", "\[Phi]ya"}]}], ")"}], 
            "2"]}]]}]}], 
       RowBox[{"\[Kappa]", " ", 
        RowBox[{"(", 
         RowBox[{"1", "+", "\[Beta]", "+", 
          RowBox[{"\[Kappa]", " ", "\[Sigma]"}], "+", 
          RowBox[{"\[Beta]", " ", "\[Sigma]", " ", "\[Phi]ya"}], "+", 
          SqrtBox[
           RowBox[{
            RowBox[{
             RowBox[{"-", "4"}], " ", "\[Kappa]", " ", "\[Sigma]", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "1"}], "+", 
               RowBox[{"\[Beta]", " ", "\[Phi]a"}]}], ")"}]}], "+", 
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "1"}], "+", "\[Beta]", "+", 
               RowBox[{"\[Kappa]", " ", "\[Sigma]"}], "+", 
               RowBox[{"\[Beta]", " ", "\[Sigma]", " ", "\[Phi]ya"}]}], ")"}],
              "2"]}]]}], ")"}]}]], "0", "0"},
     {"0", "\[Alpha]", "0", "0"},
     {"0", "\[Alpha]", "0", "0"},
     {
      RowBox[{"-", 
       FractionBox[
        RowBox[{"2", " ", "\[Kappa]"}], 
        RowBox[{"1", "+", "\[Beta]", "+", 
         RowBox[{"\[Kappa]", " ", "\[Sigma]"}], "+", 
         RowBox[{"\[Beta]", " ", "\[Sigma]", " ", "\[Phi]ya"}], "+", 
         SqrtBox[
          RowBox[{
           RowBox[{
            RowBox[{"-", "4"}], " ", "\[Kappa]", " ", "\[Sigma]", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "1"}], "+", 
              RowBox[{"\[Beta]", " ", "\[Phi]a"}]}], ")"}]}], "+", 
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "1"}], "+", "\[Beta]", "+", 
              RowBox[{"\[Kappa]", " ", "\[Sigma]"}], "+", 
              RowBox[{"\[Beta]", " ", "\[Sigma]", " ", "\[Phi]ya"}]}], ")"}], 
            "2"]}]]}]]}], 
      FractionBox[
       RowBox[{"1", "+", 
        RowBox[{"2", " ", "\[Alpha]"}], "-", "\[Beta]", "-", 
        RowBox[{"\[Kappa]", " ", "\[Sigma]"}], "+", 
        RowBox[{
        "2", " ", "\[Alpha]", " ", "\[Kappa]", " ", "\[Sigma]", " ", 
         "\[Phi]a"}], "+", 
        RowBox[{"2", " ", "\[Alpha]", " ", "\[Sigma]", " ", "\[Phi]ya"}], "-", 
        RowBox[{"\[Beta]", " ", "\[Sigma]", " ", "\[Phi]ya"}], "+", 
        SqrtBox[
         RowBox[{
          RowBox[{
           RowBox[{"-", "4"}], " ", "\[Kappa]", " ", "\[Sigma]", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "1"}], "+", 
             RowBox[{"\[Beta]", " ", "\[Phi]a"}]}], ")"}]}], "+", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "1"}], "+", "\[Beta]", "+", 
             RowBox[{"\[Kappa]", " ", "\[Sigma]"}], "+", 
             RowBox[{"\[Beta]", " ", "\[Sigma]", " ", "\[Phi]ya"}]}], ")"}], 
           "2"]}]]}], 
       RowBox[{"1", "+", "\[Beta]", "+", 
        RowBox[{"\[Kappa]", " ", "\[Sigma]"}], "+", 
        RowBox[{"\[Beta]", " ", "\[Sigma]", " ", "\[Phi]ya"}], "+", 
        SqrtBox[
         RowBox[{
          RowBox[{
           RowBox[{"-", "4"}], " ", "\[Kappa]", " ", "\[Sigma]", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "1"}], "+", 
             RowBox[{"\[Beta]", " ", "\[Phi]a"}]}], ")"}]}], "+", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "1"}], "+", "\[Beta]", "+", 
             RowBox[{"\[Kappa]", " ", "\[Sigma]"}], "+", 
             RowBox[{"\[Beta]", " ", "\[Sigma]", " ", "\[Phi]ya"}]}], ")"}], 
           "2"]}]]}]], "0", "0"}
    },
    GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Baseline}}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{{3.816668364394288*^9, 3.8166683757658615`*^9}, 
   3.8166684464867563`*^9, 3.8166684986058893`*^9, 3.8195261388258896`*^9, 
   3.8198665499299064`*^9, 3.819868387103197*^9},
 CellLabel->
  "Out[163]//MatrixForm=",ExpressionUUID->"26a82b73-1ac4-4891-ab32-\
867100ca9ee5"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{"Clearly", ",", " ", 
    RowBox[{"eigenvalues", " ", "are", " ", 
     FractionBox[
      RowBox[{"2", " ", "\[Beta]"}], 
      RowBox[{"1", "+", "\[Beta]", "+", 
       RowBox[{"\[Kappa]", " ", "\[Sigma]"}], "+", 
       RowBox[{"\[Beta]", " ", "\[Sigma]", " ", "\[Phi]ya"}], "+", 
       SqrtBox[
        RowBox[{
         RowBox[{"4", " ", "\[Kappa]", " ", "\[Sigma]", " ", 
          RowBox[{"(", 
           RowBox[{"1", "-", 
            RowBox[{"\[Beta]", " ", "\[Phi]a"}]}], ")"}]}], "+", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "1"}], "+", "\[Beta]", "+", 
            RowBox[{"\[Kappa]", " ", "\[Sigma]"}], "+", 
            RowBox[{"\[Beta]", " ", "\[Sigma]", " ", "\[Phi]ya"}]}], ")"}], 
          "2"]}]]}]], " ", "and", " ", "\[Alpha]", " ", "which", " ", "are", 
     " ", "both", " ", "less", " ", "than", " ", "one", " ", "in", " ", 
     RowBox[{"magnitude", "!"}]}]}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"SECOND", " ", 
     RowBox[{"CONDITION", ":", " ", 
      RowBox[{
       RowBox[{"trivial", "..."}], "since", " ", "eigenvalues", " ", "of", 
       " ", "F", " ", "and", " ", "BFG", " ", "are", " ", "inside", " ", 
       "unit", " ", "circle"}]}]}], ",", " ", 
    RowBox[{"so", " ", "is", " ", "r", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"kron", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"BFG", "'"}], ",", "F"}], ")"}]}], ")"}], ".", " ", 
      "Note"}], " ", "that", " ", "eigenvalue", " ", "of", " ", "BFG", " ", 
     "is", " ", "psiA", " ", "which", " ", "is", " ", "inside", " ", "the", 
     " ", "unit", " ", 
     RowBox[{"circle", "."}]}]}], "*)"}]}]], "Input",
 CellChangeTimes->{{3.816668503516757*^9, 3.8166685698638735`*^9}, {
  3.8195261526602535`*^9, 3.819526172134856*^9}, {3.819867639783778*^9, 
  3.819867645463707*^9}, {3.819867803097822*^9, 
  3.81986781953209*^9}},ExpressionUUID->"ca4c378d-8fe1-4fb0-92c5-\
d1a72c261c85"],

Cell[BoxData[""], "Input",
 CellChangeTimes->{{3.8195439805595365`*^9, 
  3.8195439841708965`*^9}},ExpressionUUID->"1feb6e66-a469-44ef-8f7d-\
967d90e94ff4"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{"Numerics", ":", " ", 
    RowBox[{"Solve", " ", "for", " ", "stable", " ", "root"}]}], "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"\[Beta]", "=", ".99"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"\[Kappa]", " ", "=", ".1"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"\[Sigma]", "=", "1"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"\[Phi]a", "=", "0.4"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"\[Phi]ya", "=", "0.4"}], ";"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{"Plot", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       FractionBox[
        RowBox[{"1", "+", 
         RowBox[{"\[Kappa]", " ", "\[Sigma]", " ", "\[Phi]a"}], "+", 
         RowBox[{"\[Sigma]", " ", "\[Phi]ya"}]}], 
        RowBox[{"1", "+", "\[Beta]", "-", 
         RowBox[{"x", " ", "\[Beta]"}], "+", 
         RowBox[{"\[Kappa]", " ", "\[Sigma]"}], "+", 
         RowBox[{"\[Beta]", " ", "\[Sigma]", " ", "\[Phi]ya"}]}]], ",", "x"}],
       "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"x", ",", "0", ",", "2"}], "}"}]}], "]"}], 
   "\[IndentingNewLine]"}]}]], "Input",
 CellChangeTimes->{{3.8198684436457047`*^9, 3.819868448070877*^9}},
 CellLabel->
  "In[164]:=",ExpressionUUID->"62325a83-1313-4a81-a7d2-fec3708a2f9e"],

Cell[BoxData[
 GraphicsBox[{{{}, {}, 
    TagBox[
     {RGBColor[0.368417, 0.506779, 0.709798], AbsoluteThickness[1.6], Opacity[
      1.], LineBox[CompressedData["
1:eJwVkHk4lAkAhx0zk11FotohVygmwpCS7O9bHXIl4qHdDpGzNhVtRe005cqR
2cIqiihtEWGmRzXiKVQqEq2U0Gfc0ziHkPm2/eN93uf999X3D/cMVJCTk3P7
zv92Duxvqh4I/Lkt+JQ96zwJ2kbNw53MTZjTvaW8I5GEVU5mdjnTC1x/qSw6
iYTL69ayq8z9MD74k3dDCgmf/VOVF5mRsFq/oTryIolP5vEbU5gxMKvVznye
RSJ3sXtcIjMN6omVnORiElyl8pXnmTfQyJmtimsh4bvzesnIKB9UT3LEjHE3
lCnuLkedKhg4tQmSo7ph5CHpf5pUA3n/mFr2624cb7BF5sQL6NRa8OVZIizl
q3XIyzfigeKKpMpzItwnN75q3PAWWYJwwaV+EZ6EXdXaKW7BsEPTZKh7D6Qr
7FXv/t6Kiixh0FRZDxSmCxdqGX0AXalAT8ugFzaU3/0dxe142NyUIE3txasY
64Y6VidOKP7xpkHWC13e0PRtSReSTYXnZdF9GJrq7HhnQeJOCykpl/bhxuCj
epUL3egonyA8Of1Q0b41LBKJ0CXn8ow3fwDJoYKgXMNeBDlUNBllDGCSKBSF
cPrATtj0zYo9iEh2DX/J036E6+UaPagfRGdxTVKT/iDY3opS2okhzIa1ZJlE
DcGuYiC6hyXGql/myYIeiXHZhmSYfRDDMU8/uHSpBLy09HjNvC84rr13+edd
w+gP1HhfHySBqdhbudVtBH7X3Rc/sxyGuuqIUs3MCLaMBlxeuWAEtKqsEoPs
UVhqLuZKOCM4YP2o7QeXMeRpP+S9VBxFoZN/7uPJMZhv8PnzXMoopEOaC3sz
xmH+smJ6wZIxCHY4KqZtmkBRW9La5vIxcLbG5vB7J3A89Eqersc49D85v8+P
leKY0KPunnQc69fGpDHZk6jfW6CqI5jALp3GafnmSag0LmvSPSaFtD6FPMyd
Ql25/1CO9yQyaXsiPQ2/IvjstcjodVNQ7xDkKdR8RYYe65y6yVfQT3O9bI9M
48B2a7bG5mnI3d5TQi6agYKJ/aEHQTM4eqUkZdGTGVTKlartq5pF5aoEJbVD
s3gaZTC/es0c1JyPmp5V+YbcA6c/B1TI0G72pvmk8BtW1BrEP94sR9y7BkPR
njm4FMbecVkvT+wusVHTls3B6WzZcLajAnEm9jq3/Y4MqsdstxdcUiTu9mtn
qbhSyP01niWbpBEJV2P9OrZRcLNeGpE/RyP2e34xKvagwPn3r3FXGp1YJhTe
c/OhUHfTv6hIjU4kpv5Wl+xPId3SIzzHlE6E2Fwe/fHk9+amf/AOoBPLYzS2
ziugIHSwDDZsoROydacWtP5DwfxubqfvRzrR9qX7bUEhhdPK9loXSTrB8ynf
vaWUQpiXWLJolE5QLM+IWCGFKD2NC9tUGER7U+o1xWYKXSHLR0qdGERF3FRA
8zsKIS7CLmsPBpFmt9ck/z2FMj2LbqEvg3C5uZrv0EHhjLMduz2YQTw88foF
d4DCya2cRN84BpFhtibVQ0xhdaBvFu0CgzhCZnvpD3//YSPpE6QzCGPXg53V
ExTWvn3hZHyTQdDkW27wpiisEneEDhQxiC6BXZjfDIX7Ee4fS/gMQhiWb24x
R8G2KD0/Wsgg/tZVllIUBd4+q+euNQziPxD4Z5w=
       "]]},
     Annotation[#, "Charting`Private`Tag$27776#1"]& ], 
    TagBox[
     {RGBColor[0.880722, 0.611041, 0.142051], AbsoluteThickness[1.6], Opacity[
      1.], LineBox[CompressedData["
1:eJxFxW0w03EcAPCNdZRrjMr9adxE5SlOUlKpuMhDndHJ5emEtJ6QO+nqtG6T
PMR1OynPDyntGNlcl4lj547zEONGN5tmp7F5KrNGtuqF7+/F5z6UhHvUJAMc
Dhf6z/+DkhSj3fNJZ7Yn+FmlSjF/3+2PVpWWt2ERcPCQ6GMFlghHJmo6X2IZ
8LTbM79CjAFX772ck4exYLpx26HnWD18NaqGs7LKhU309OgAmy7YIWxJ0Zsv
gDOHvX1L1/phSy5JgsePwO0yv8GRU2NwD63COko1DqsPnjZtuiOCDbRsM2uH
b7CXPr49vFkMDzI8h/ucpLBtsVLbuDQDKzVSyYS7DK5f6BggvpiFieR3y3K5
HC64yUuutp+D18+y5SnZP+AMDwF3X68CljYL8kcpC/AmbbzM8aESdj5npEvu
UMEBtZQbrZZLcCY5zu579DLsorpiIgpdgS1MV4wFG2hCVxnnQPkqfMuzY2pn
8E+YfTGh+ss6Wq20Mpsr+QXzwgMMWf5rcHYgs4o7h6ZMB03WMdXwyeMMFuax
DkfbjGjxQrR6oFCWStfApYTYDKr9b9hCwqs1EKB3PKZHeKdpYVxjLEdmvgGn
v+EUmvegO51zjUl3N2FSULrLU+IfWOz6VZjFR7dU+trLY7fgGI4XiaxDP2HW
0MUfdHCTglxGDNHDuRXMeMkldCJ10aE5DL2fz28JjUTnFV3rK0hAp3i9Xt2V
hbZj7Ak0akDrTjzaLXqPnlqcHWtgo4sj22IutKL1TtT7TD5aPFpUaShEf8rR
XBdOoFk+cY51k+jgt0e45yXozw+G+unz6BLXY0VhKnSarDyCsow+HHJb2r2G
JuDH64s16BmeDy1+A82n1bm5b6Ff2Zqo9Xr0X7rRg+M=
       "]]},
     Annotation[#, "Charting`Private`Tag$27776#2"]& ]}, {}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{True, True},
  AxesLabel->{None, None},
  AxesOrigin->{0, 0},
  DisplayFunction->Identity,
  Frame->{{False, False}, {False, False}},
  FrameLabel->{{None, None}, {None, None}},
  FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
  GridLines->{None, None},
  GridLinesStyle->Directive[
    GrayLevel[0.5, 0.4]],
  ImagePadding->All,
  Method->{
   "DefaultBoundaryStyle" -> Automatic, 
    "DefaultGraphicsInteraction" -> {
     "Version" -> 1.2, "TrackMousePosition" -> {True, False}, 
      "Effects" -> {
       "Highlight" -> {"ratio" -> 2}, "HighlightPoint" -> {"ratio" -> 2}, 
        "Droplines" -> {
         "freeformCursorMode" -> True, 
          "placement" -> {"x" -> "All", "y" -> "None"}}}}, "DefaultMeshStyle" -> 
    AbsolutePointSize[6], "ScalingFunctions" -> None, 
    "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& ), "CopiedValueFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& )}},
  PlotRange->{{0, 2}, {0., 2.8458495751076}},
  PlotRangeClipping->True,
  PlotRangePadding->{{
     Scaled[0.02], 
     Scaled[0.02]}, {
     Scaled[0.05], 
     Scaled[0.05]}},
  Ticks->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{3.8198684518832664`*^9},
 CellLabel->
  "Out[169]=",ExpressionUUID->"383010f9-e37c-49f9-bdd6-9debff4c0cfe"]
}, Open  ]]
},
WindowSize->{724.5, 453.},
WindowMargins->{{26, Automatic}, {-76, Automatic}},
Magnification:>0.8 Inherited,
FrontEndVersion->"12.1 for Microsoft Windows (64-bit) (June 19, 2020)",
StyleDefinitions->"Default.nb",
ExpressionUUID->"9dba1cbc-6d7c-452e-895d-341a7b13ee81"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[580, 22, 6456, 179, 355, "Input",ExpressionUUID->"11915e7c-9506-4e99-8ec3-83dae53a0432"],
Cell[7039, 203, 3982, 102, 161, "Output",ExpressionUUID->"a47bf44a-64b6-4c02-98c7-4aed8bbc184c"]
}, Open  ]],
Cell[CellGroupData[{
Cell[11058, 310, 444, 9, 68, "Input",ExpressionUUID->"fd91ec4f-cc4d-4ffb-a2df-393141d49262"],
Cell[11505, 321, 4286, 111, 111, "Output",ExpressionUUID->"b941a2e9-a608-4c01-9bd6-f8954236181a"]
}, Open  ]],
Cell[15806, 435, 154, 3, 22, "Input",ExpressionUUID->"03160197-4c9d-444b-8b1a-445347603cbe"],
Cell[CellGroupData[{
Cell[15985, 442, 2513, 63, 103, "Input",ExpressionUUID->"6c1e0aa7-c4c2-4da7-a618-75619249ae79"],
Cell[18501, 507, 204, 4, 25, "Output",ExpressionUUID->"9252847f-7af1-4d3b-b16d-4c95179afe2c"]
}, Open  ]],
Cell[CellGroupData[{
Cell[18742, 516, 6343, 176, 348, "Input",ExpressionUUID->"fbd3e788-3c9b-4109-b0c5-d63d086acfbd"],
Cell[25088, 694, 175, 3, 25, "Output",ExpressionUUID->"632989b1-2091-48ac-af0d-65f6bb5f259e"],
Cell[25266, 699, 175, 3, 25, "Output",ExpressionUUID->"4a0c7578-c0ba-42b8-8172-2c73fe2dda91"],
Cell[25444, 704, 666, 17, 45, "Output",ExpressionUUID->"a896a011-a688-44a2-a785-e52f4397d075"],
Cell[26113, 723, 459, 13, 42, "Output",ExpressionUUID->"5bf51d5e-8e8c-492f-8f2b-b415308e288e"]
}, Open  ]],
Cell[CellGroupData[{
Cell[26609, 741, 1695, 42, 105, "Input",ExpressionUUID->"63773ea2-0d7f-49c8-a3e9-5feeea369a15"],
Cell[28307, 785, 234, 5, 25, "Output",ExpressionUUID->"0139f3ac-b250-42c0-ad88-acde2386678d"]
}, Open  ]],
Cell[28556, 793, 2498, 69, 169, "Input",ExpressionUUID->"fc790c2e-c425-43a8-8600-37411f5dc5f3"],
Cell[CellGroupData[{
Cell[31079, 866, 4627, 130, 282, "Input",ExpressionUUID->"d96e7f2b-86a7-4041-b347-476291790e8b"],
Cell[35709, 998, 2754, 70, 77, "Output",ExpressionUUID->"5b19c6fb-e665-4a7d-a1ca-42ba36054d26"]
}, Open  ]],
Cell[CellGroupData[{
Cell[38500, 1073, 1591, 37, 39, "Input",ExpressionUUID->"54269259-7143-4ac7-bf25-8c20f74774a6"],
Cell[40094, 1112, 380, 7, 25, "Output",ExpressionUUID->"fbf2585e-f039-407b-973f-767e0aeef8f3"]
}, Open  ]],
Cell[CellGroupData[{
Cell[40511, 1124, 2051, 54, 116, "Input",ExpressionUUID->"4a12d9e1-f6be-4389-b08c-017617b23524"],
Cell[42565, 1180, 2607, 67, 77, "Output",ExpressionUUID->"a0a66e5b-4b3f-4797-b191-0104512eefeb"]
}, Open  ]],
Cell[CellGroupData[{
Cell[45209, 1252, 1285, 32, 39, "Input",ExpressionUUID->"89275e4e-ea01-42a9-9038-4d491f9ffd73"],
Cell[46497, 1286, 204, 4, 25, "Output",ExpressionUUID->"87da1e0e-393a-4fc3-86c9-6e6fb271b9d8"]
}, Open  ]],
Cell[46716, 1293, 2805, 73, 164, "Input",ExpressionUUID->"9db4187c-318e-4c5e-8f76-88b24b611053"],
Cell[49524, 1368, 5532, 150, 300, "Input",ExpressionUUID->"bd491e56-c14b-4891-acea-dffefbd60a2d"],
Cell[CellGroupData[{
Cell[55081, 1522, 1143, 25, 56, "Input",ExpressionUUID->"e91a86a8-6f70-4747-b450-1dee65695723"],
Cell[56227, 1549, 2058, 51, 85, "Output",ExpressionUUID->"b6bb4e84-9958-41bb-a395-7cf162c06e59"]
}, Open  ]],
Cell[58300, 1603, 343, 8, 22, "Input",ExpressionUUID->"f5b756fe-fbaa-4368-b2cf-0efcc04434ef"],
Cell[CellGroupData[{
Cell[58668, 1615, 1614, 43, 86, "Input",ExpressionUUID->"65ee3a95-5a40-48db-b60b-1d7d0a861446"],
Cell[60285, 1660, 179, 3, 25, "Output",ExpressionUUID->"0a84877e-4259-4f2c-8f58-28f430ebce5a"]
}, Open  ]],
Cell[60479, 1666, 1193, 27, 53, "Input",ExpressionUUID->"8339c3ba-7f97-414d-abf5-5bc3b2e91517"],
Cell[61675, 1695, 1765, 45, 86, "Input",ExpressionUUID->"b0b44f54-58fa-4c7f-8e84-2105bb9ea39e"],
Cell[CellGroupData[{
Cell[63465, 1744, 6686, 174, 456, "Input",ExpressionUUID->"0f100a14-8db5-4522-848e-1f9d000add04"],
Cell[70154, 1920, 4187, 109, 111, "Output",ExpressionUUID->"7b420dc3-ae0a-4624-b913-d0abe803f5a8"]
}, Open  ]],
Cell[CellGroupData[{
Cell[74378, 2034, 1136, 28, 45, "Input",ExpressionUUID->"3572788c-490e-4b85-af93-4b80c872a209"],
Cell[75517, 2064, 327, 6, 25, "Output",ExpressionUUID->"de64da7b-5a5e-4a4f-8fd6-60fb5067870a"]
}, Open  ]],
Cell[CellGroupData[{
Cell[75881, 2075, 1599, 40, 113, "Input",ExpressionUUID->"8f561131-f7c2-4d68-95b5-8dabd7e6b9fd"],
Cell[77483, 2117, 6869, 172, 111, "Output",ExpressionUUID->"26a82b73-1ac4-4891-ab32-867100ca9ee5"]
}, Open  ]],
Cell[84367, 2292, 2052, 48, 80, "Input",ExpressionUUID->"ca4c378d-8fe1-4fb0-92c5-d1a72c261c85"],
Cell[86422, 2342, 156, 3, 22, "Input",ExpressionUUID->"1feb6e66-a469-44ef-8f7d-967d90e94ff4"],
Cell[CellGroupData[{
Cell[86603, 2349, 1413, 36, 192, "Input",ExpressionUUID->"62325a83-1313-4a81-a7d2-fec3708a2f9e"],
Cell[88019, 2387, 4528, 96, 217, "Output",ExpressionUUID->"383010f9-e37c-49f9-bdd6-9debff4c0cfe"]
}, Open  ]]
}
]
*)

